<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'headerType' => '\\StructType\\HeaderType',
            'rueckmeldungType' => '\\StructType\\RueckmeldungType',
            'attachmentinfoList' => '\\StructType\\AttachmentinfoList',
            'partnerType' => '\\StructType\\PartnerType',
            'zahlungsdatenType' => '\\StructType\\ZahlungsdatenType',
            'identifikationZuordnungType' => '\\StructType\\IdentifikationZuordnungType',
            'kontierungsdatenType' => '\\StructType\\KontierungsdatenType',
            'kontierungszeileType' => '\\StructType\\KontierungszeileType',
            'vinkularglaeubigerType' => '\\StructType\\VinkularglaeubigerType',
            'kommunikationType' => '\\StructType\\KommunikationType',
            'praemienpruefungType' => '\\StructType\\PraemienpruefungType',
            'datenverwendungType' => '\\StructType\\DatenverwendungType',
            'anmeldungKundenportalType' => '\\StructType\\AnmeldungKundenportalType',
            'praemieninfoType' => '\\StructType\\PraemieninfoType',
            'attachmentinfoType' => '\\StructType\\AttachmentinfoType',
            'beratungsdokumentationType' => '\\StructType\\BeratungsdokumentationType',
            'generalikfzv2Type' => '\\StructType\\Generalikfzv2Type',
            'zulassungsdatenType' => '\\StructType\\ZulassungsdatenType',
            'versicherungsbestaetigungType' => '\\StructType\\VersicherungsbestaetigungType',
            'tarifierungsdatenType' => '\\StructType\\TarifierungsdatenType',
            'fahrzeugdatenPkwType' => '\\StructType\\FahrzeugdatenPkwType',
            'fahrzeugdatenLkwType' => '\\StructType\\FahrzeugdatenLkwType',
            'haftpflichtType' => '\\StructType\\HaftpflichtType',
            'kaskoType' => '\\StructType\\KaskoType',
            'insassenunfallType' => '\\StructType\\InsassenunfallType',
            'rechtschutzType' => '\\StructType\\RechtschutzType',
            'vereinbarungenType' => '\\StructType\\VereinbarungenType',
            'sonderausstattungTyp' => '\\StructType\\SonderausstattungTyp',
            'versichertesFahrzeugType' => '\\StructType\\VersichertesFahrzeugType',
            'versicherteFahrzeugeType' => '\\StructType\\VersicherteFahrzeugeType',
            'rsVerkehrsbereichsType' => '\\StructType\\RsVerkehrsbereichsType',
            'privatBerufsbereichsRechtsschutzType' => '\\StructType\\PrivatBerufsbereichsRechtsschutzType',
            'berufsBereichsRechtsschutzType' => '\\StructType\\BerufsBereichsRechtsschutzType',
            'vereinbarungenHaftpflichtType' => '\\StructType\\VereinbarungenHaftpflichtType',
            'vereinbarungenKaskoType' => '\\StructType\\VereinbarungenKaskoType',
            'vereinbarungenInsassenunfallType' => '\\StructType\\VereinbarungenInsassenunfallType',
            'vereinbarungenRechtsschutz' => '\\StructType\\VereinbarungenRechtsschutz',
            'sonderrabattType' => '\\StructType\\SonderrabattType',
            'antragsdatenType' => '\\StructType\\AntragsdatenType',
            'ersatzpolizzenType' => '\\StructType\\ErsatzpolizzenType',
            'zusaetzlicheKfzdatenType' => '\\StructType\\ZusaetzlicheKfzdatenType',
            'wechselkennzeichenType' => '\\StructType\\WechselkennzeichenType',
            'bonusMalusSystemType' => '\\StructType\\BonusMalusSystemType',
            'offeneSchaedenType' => '\\StructType\\OffeneSchaedenType',
            'offenerSchadenType' => '\\StructType\\OffenerSchadenType',
            'fahrzeugnutzungType' => '\\StructType\\FahrzeugnutzungType',
            'vorversicherungenType' => '\\StructType\\VorversicherungenType',
            'vorversicherungenDetailType' => '\\StructType\\VorversicherungenDetailType',
            'fahrzeugzustandType' => '\\StructType\\FahrzeugzustandType',
            'antragrechtsschutzdatenType' => '\\StructType\\AntragrechtsschutzdatenType',
            'adressePrivatobjektType' => '\\StructType\\AdressePrivatobjektType',
            'generaliprivatType' => '\\StructType\\GeneraliprivatType',
            'risikoEigenheimType' => '\\StructType\\RisikoEigenheimType',
            'risikoHHimMFHType' => '\\StructType\\RisikoHHimMFHType',
            'risikoAdresseType' => '\\StructType\\RisikoAdresseType',
            'deckungVsType' => '\\StructType\\DeckungVsType',
            'deckungProzentType' => '\\StructType\\DeckungProzentType',
            'EvpServiceFault' => '\\StructType\\EvpServiceFault',
            'Abstractor' => '\\StructType\\Abstractor',
            'Adress' => '\\StructType\\Adress',
            'HoraAdress' => '\\StructType\\HoraAdress',
            'ArcContent' => '\\StructType\\ArcContent',
            'ArcImageInfo' => '\\StructType\\ArcImageInfo',
            'Attachment' => '\\StructType\\Attachment',
            'Attribute' => '\\StructType\\Attribute',
            'BankAccount' => '\\StructType\\BankAccount',
            'BonusMalus' => '\\StructType\\BonusMalus',
            'BusinessCase' => '\\StructType\\BusinessCase',
            'frameAgreement' => '\\StructType\\FrameAgreement',
            'consultationProtocoll' => '\\StructType\\ConsultationProtocoll',
            'BusinessCaseInsuranceHolder' => '\\StructType\\BusinessCaseInsuranceHolder',
            'Claim' => '\\StructType\\Claim',
            'CommunicationDetails' => '\\StructType\\CommunicationDetails',
            'KundenportalNewsletterEmail' => '\\StructType\\KundenportalNewsletterEmail',
            'Contact' => '\\StructType\\Contact',
            'Contract' => '\\StructType\\Contract',
            'data' => '\\StructType\\Data',
            'omdsData' => '\\StructType\\OmdsData',
            'customers' => '\\StructType\\Customers',
            'additionalContractData' => '\\StructType\\AdditionalContractData',
            'ContractSearch' => '\\StructType\\ContractSearch',
            'ContractSearchDetail' => '\\StructType\\ContractSearchDetail',
            'Consultation_SMOnline' => '\\StructType\\Consultation_SMOnline',
            'Consultation_ContractData' => '\\StructType\\Consultation_ContractData',
            'Country' => '\\StructType\\Country',
            'Customer' => '\\StructType\\Customer',
            'DataForPolicy' => '\\StructType\\DataForPolicy',
            'History' => '\\StructType\\History',
            'HistoryContract' => '\\StructType\\HistoryContract',
            'HistoryEsam' => '\\StructType\\HistoryEsam',
            'Identification' => '\\StructType\\Identification',
            'KeyValuePair' => '\\StructType\\KeyValuePair',
            'Login' => '\\StructType\\Login',
            'PartnerRoles' => '\\StructType\\PartnerRoles',
            'Policy' => '\\StructType\\Policy',
            'PolicyPartnerRole' => '\\StructType\\PolicyPartnerRole',
            'PrintDocument' => '\\StructType\\PrintDocument',
            'Recipient' => '\\StructType\\Recipient',
            'Request' => '\\StructType\\Request',
            'SocialInsurance' => '\\StructType\\SocialInsurance',
            'State' => '\\StructType\\State',
            'User' => '\\StructType\\User',
            'Vinkulierungsdaten' => '\\StructType\\Vinkulierungsdaten',
            'ZeusCar' => '\\StructType\\ZeusCar',
            'ZeusCarFileData' => '\\StructType\\ZeusCarFileData',
            'addStateHistoryEntryRequest' => '\\StructType\\AddStateHistoryEntryRequest',
            'addStateHistoryEntryResponse' => '\\StructType\\AddStateHistoryEntryResponse',
            'browseMessageFromMQRequest' => '\\StructType\\BrowseMessageFromMQRequest',
            'browseMessageFromMQResponse' => '\\StructType\\BrowseMessageFromMQResponse',
            'browseMessageFromMQResponseBase64Encoded' => '\\StructType\\BrowseMessageFromMQResponseBase64Encoded',
            'calculatePremiumOnlyRequest' => '\\StructType\\CalculatePremiumOnlyRequest',
            'calculatePremiumOnlyResponse' => '\\StructType\\CalculatePremiumOnlyResponse',
            'getChoiceListsRequest' => '\\StructType\\GetChoiceListsRequest',
            'getChoiceListsResponse' => '\\StructType\\GetChoiceListsResponse',
            'getArcImageRequest' => '\\StructType\\GetArcImageRequest',
            'getArcImageResponse' => '\\StructType\\GetArcImageResponse',
            'getArcImageInfosRequest' => '\\StructType\\GetArcImageInfosRequest',
            'getArcImageInfosResponse' => '\\StructType\\GetArcImageInfosResponse',
            'getBusinessCaseReadonlyLinkRequest' => '\\StructType\\GetBusinessCaseReadonlyLinkRequest',
            'getBusinessCaseReadonlyLinkResponse' => '\\StructType\\GetBusinessCaseReadonlyLinkResponse',
            'getBusinessCaseRequest' => '\\StructType\\GetBusinessCaseRequest',
            'getBusinessCaseResponse' => '\\StructType\\GetBusinessCaseResponse',
            'getBusinessCaseHistoryRequest' => '\\StructType\\GetBusinessCaseHistoryRequest',
            'getBusinessCaseHistoryResponse' => '\\StructType\\GetBusinessCaseHistoryResponse',
            'getBusinessCasesRequest' => '\\StructType\\GetBusinessCasesRequest',
            'getBusinessCasesResponse' => '\\StructType\\GetBusinessCasesResponse',
            'getBusinessCaseTypesRequest' => '\\StructType\\GetBusinessCaseTypesRequest',
            'getBusinessCaseTypesResponse' => '\\StructType\\GetBusinessCaseTypesResponse',
            'getBusinessCollectionDataRequest' => '\\StructType\\GetBusinessCollectionDataRequest',
            'getBusinessCollectionDataResponse' => '\\StructType\\GetBusinessCollectionDataResponse',
            'getContractRequest' => '\\StructType\\GetContractRequest',
            'getContractResponse' => '\\StructType\\GetContractResponse',
            'getBerechnungswerteRequest' => '\\StructType\\GetBerechnungswerteRequest',
            'getBerechnungswerteResponse' => '\\StructType\\GetBerechnungswerteResponse',
            'BerechnungswerteType' => '\\StructType\\BerechnungswerteType',
            'getContractsRequest' => '\\StructType\\GetContractsRequest',
            'getContractsResponse' => '\\StructType\\GetContractsResponse',
            'getLatestIDFromNumbergeneratorRequest' => '\\StructType\\GetLatestIDFromNumbergeneratorRequest',
            'getLatestIDFromNumbergeneratorResponse' => '\\StructType\\GetLatestIDFromNumbergeneratorResponse',
            'getVersionRequest' => '\\StructType\\GetVersionRequest',
            'getVersionResponse' => '\\StructType\\GetVersionResponse',
            'getZeusDatenRequest' => '\\StructType\\GetZeusDatenRequest',
            'getZeusDatenResponse' => '\\StructType\\GetZeusDatenResponse',
            'hasZeusDatenRequest' => '\\StructType\\HasZeusDatenRequest',
            'hasZeusDatenResponse' => '\\StructType\\HasZeusDatenResponse',
            'getZeusDatenGrecoRequest' => '\\StructType\\GetZeusDatenGrecoRequest',
            'getZeusDatenGrecoResponse' => '\\StructType\\GetZeusDatenGrecoResponse',
            'getVinkulierungsdatenRequest' => '\\StructType\\GetVinkulierungsdatenRequest',
            'getVinkulierungsdatenResponse' => '\\StructType\\GetVinkulierungsdatenResponse',
            'mapCustomerToPAPartnerRequest' => '\\StructType\\MapCustomerToPAPartnerRequest',
            'mapCustomerToPAPartnerResponse' => '\\StructType\\MapCustomerToPAPartnerResponse',
            'loginRequest' => '\\StructType\\LoginRequest',
            'loginResponse' => '\\StructType\\LoginResponse',
            'getUserDataRequest' => '\\StructType\\GetUserDataRequest',
            'getUserDataResponse' => '\\StructType\\GetUserDataResponse',
            'deleteUserDataTokensRequest' => '\\StructType\\DeleteUserDataTokensRequest',
            'deleteUserDataTokensResponse' => '\\StructType\\DeleteUserDataTokensResponse',
            'kundenportalJwtInvalidateServiceRequest' => '\\StructType\\KundenportalJwtInvalidateServiceRequest',
            'kundenportalJwtInvalidateServiceResponse' => '\\StructType\\KundenportalJwtInvalidateServiceResponse',
            'kundenportalBenutzerPasswortAendernRequest' => '\\StructType\\KundenportalBenutzerPasswortAendernRequest',
            'kundenportalBenutzerPasswortAendernResponse' => '\\StructType\\KundenportalBenutzerPasswortAendernResponse',
            'kundenportalBenutzernameAendernRequest' => '\\StructType\\KundenportalBenutzernameAendernRequest',
            'kundenportalBenutzernameAendernResponse' => '\\StructType\\KundenportalBenutzernameAendernResponse',
            'UserToken' => '\\StructType\\UserToken',
            'isValidSchadensnummerNachnameRequest' => '\\StructType\\IsValidSchadensnummerNachnameRequest',
            'isValidSchadensnummerNachnameResponse' => '\\StructType\\IsValidSchadensnummerNachnameResponse',
            'orderGreenOrServiceCardRequest' => '\\StructType\\OrderGreenOrServiceCardRequest',
            'orderGreenOrServiceCardResponse' => '\\StructType\\OrderGreenOrServiceCardResponse',
            'getHoraZoneRequest' => '\\StructType\\GetHoraZoneRequest',
            'getHoraZoneResponse' => '\\StructType\\GetHoraZoneResponse',
            'newBusinessCaseRequest' => '\\StructType\\NewBusinessCaseRequest',
            'newBusinessCaseResponse' => '\\StructType\\NewBusinessCaseResponse',
            'newBusinessCasePrefilledRequest' => '\\StructType\\NewBusinessCasePrefilledRequest',
            'PaCustomer' => '\\StructType\\PaCustomer',
            'newBusinessCasePrefilledResponse' => '\\StructType\\NewBusinessCasePrefilledResponse',
            'newBusinessCaseCalculateAndSaveRequest' => '\\StructType\\NewBusinessCaseCalculateAndSaveRequest',
            'newBusinessCaseCalculateAndSaveResponse' => '\\StructType\\NewBusinessCaseCalculateAndSaveResponse',
            'newBusinessCaseIVOnlineRequest' => '\\StructType\\NewBusinessCaseIVOnlineRequest',
            'newBusinessCaseIVOnlineResponse' => '\\StructType\\NewBusinessCaseIVOnlineResponse',
            'newBusinessCaseInkassoAenderungRequest' => '\\StructType\\NewBusinessCaseInkassoAenderungRequest',
            'newBusinessCaseInkassoAenderungResponse' => '\\StructType\\NewBusinessCaseInkassoAenderungResponse',
            'newBusinessCaseVersicherungsBestaetigungRequest' => '\\StructType\\NewBusinessCaseVersicherungsBestaetigungRequest',
            'newBusinessCaseVersicherungsBestaetigungResponse' => '\\StructType\\NewBusinessCaseVersicherungsBestaetigungResponse',
            'newBusinessCaseStornoRequest' => '\\StructType\\NewBusinessCaseStornoRequest',
            'newBusinessCaseStornoResponse' => '\\StructType\\NewBusinessCaseStornoResponse',
            'newBusinessCaseSMOnlineRequest' => '\\StructType\\NewBusinessCaseSMOnlineRequest',
            'newBusinessCaseSMOnlineResponse' => '\\StructType\\NewBusinessCaseSMOnlineResponse',
            'newBusinessCaseSMOnlineTransferRequest' => '\\StructType\\NewBusinessCaseSMOnlineTransferRequest',
            'newBusinessCaseSMOnlineTransferResponse' => '\\StructType\\NewBusinessCaseSMOnlineTransferResponse',
            'newBusinessCaseToPolicyRequest' => '\\StructType\\NewBusinessCaseToPolicyRequest',
            'newBusinessCaseToPolicyResponse' => '\\StructType\\NewBusinessCaseToPolicyResponse',
            'addCustomerToBusinessCaseRequest' => '\\StructType\\AddCustomerToBusinessCaseRequest',
            'addCustomerToBusinessCaseResponse' => '\\StructType\\AddCustomerToBusinessCaseResponse',
            'newBusinessCaseFromXmlRequest' => '\\StructType\\NewBusinessCaseFromXmlRequest',
            'newBusinessCaseFromXmlResponse' => '\\StructType\\NewBusinessCaseFromXmlResponse',
            'removeCustomerRequest' => '\\StructType\\RemoveCustomerRequest',
            'removeCustomerResponse' => '\\StructType\\RemoveCustomerResponse',
            'searchClaimRequest' => '\\StructType\\SearchClaimRequest',
            'searchClaimResponse' => '\\StructType\\SearchClaimResponse',
            'searchClaimListRequest' => '\\StructType\\SearchClaimListRequest',
            'searchClaimListResponse' => '\\StructType\\SearchClaimListResponse',
            'searchContractRequest' => '\\StructType\\SearchContractRequest',
            'searchContractResponse' => '\\StructType\\SearchContractResponse',
            'searchContractListRequest' => '\\StructType\\SearchContractListRequest',
            'searchContractListResponse' => '\\StructType\\SearchContractListResponse',
            'getCustomerRequest' => '\\StructType\\GetCustomerRequest',
            'getCustomerResponse' => '\\StructType\\GetCustomerResponse',
            'sendCustomerRequest' => '\\StructType\\SendCustomerRequest',
            'sendCustomerResponse' => '\\StructType\\SendCustomerResponse',
            'createPartnerGroupRequest' => '\\StructType\\CreatePartnerGroupRequest',
            'createPartnerGroupResponse' => '\\StructType\\CreatePartnerGroupResponse',
            'sendMessageToMQRequest' => '\\StructType\\SendMessageToMQRequest',
            'sendMessageToMQResponse' => '\\StructType\\SendMessageToMQResponse',
            'transferSignedDocumentRequest' => '\\StructType\\TransferSignedDocumentRequest',
            'transferSignedDocumentResponse' => '\\StructType\\TransferSignedDocumentResponse',
            'transferBusinessCaseRequest' => '\\StructType\\TransferBusinessCaseRequest',
            'transferBusinessCaseResponse' => '\\StructType\\TransferBusinessCaseResponse',
            'transferBusinessCasesRequest' => '\\StructType\\TransferBusinessCasesRequest',
            'transferBusinessCasesResponse' => '\\StructType\\TransferBusinessCasesResponse',
            'Intervention' => '\\StructType\\Intervention',
            'MessageHeader' => '\\StructType\\MessageHeader',
            'Advisor' => '\\StructType\\Advisor',
            'Message' => '\\StructType\\Message',
            'Claiment' => '\\StructType\\Claiment',
            'ClaimentFirma' => '\\StructType\\ClaimentFirma',
            'ClaimentPerson' => '\\StructType\\ClaimentPerson',
            'ClaimentContactData' => '\\StructType\\ClaimentContactData',
            'BankAccountOwner' => '\\StructType\\BankAccountOwner',
            'UserType' => '\\StructType\\UserType',
            'PraemienreduktionType' => '\\StructType\\PraemienreduktionType',
            'FondsType' => '\\StructType\\FondsType',
            'EinzelfondsType' => '\\StructType\\EinzelfondsType',
            'ITAssistance' => '\\StructType\\ITAssistance',
            'Chat' => '\\StructType\\Chat',
            'OMDSPackage' => '\\StructType\\OMDSPackage',
            'OMDSPackageInfo' => '\\StructType\\OMDSPackageInfo',
            'itChatRequest' => '\\StructType\\ItChatRequest',
            'itChatResponse' => '\\StructType\\ItChatResponse',
            'PushNachrichtDetails' => '\\StructType\\PushNachrichtDetails',
            'ChoiceList' => '\\StructType\\ChoiceList',
            'ChoiceListEntry' => '\\StructType\\ChoiceListEntry',
            'TypAnsprechpartner' => '\\StructType\\TypAnsprechpartner',
            'getSignableDocumentsRequest' => '\\StructType\\GetSignableDocumentsRequest',
            'getSignableDocumentsResponse' => '\\StructType\\GetSignableDocumentsResponse',
            'SignableDocumentType' => '\\StructType\\SignableDocumentType',
            'signDocumentsRequest' => '\\StructType\\SignDocumentsRequest',
            'signDocumentsResponse' => '\\StructType\\SignDocumentsResponse',
            'getAreDocumentsSignedRequest' => '\\StructType\\GetAreDocumentsSignedRequest',
            'getAreDocumentsSignedResponse' => '\\StructType\\GetAreDocumentsSignedResponse',
            'resetSignDocumentsRequest' => '\\StructType\\ResetSignDocumentsRequest',
            'resetSignDocumentsResponse' => '\\StructType\\ResetSignDocumentsResponse',
            'getSignedDocumentsRequest' => '\\StructType\\GetSignedDocumentsRequest',
            'getSignedDocumentsResponse' => '\\StructType\\GetSignedDocumentsResponse',
            'createOrUpdatePartnerContactRequest' => '\\StructType\\CreateOrUpdatePartnerContactRequest',
            'createOrUpdatePartnerContactResponse' => '\\StructType\\CreateOrUpdatePartnerContactResponse',
            'kundenportalClaimAdviceInitialRequest' => '\\StructType\\KundenportalClaimAdviceInitialRequest',
            'kundenportalClaimAdviceInitialResponse' => '\\StructType\\KundenportalClaimAdviceInitialResponse',
            'kundenportalClaimAdviceRequest' => '\\StructType\\KundenportalClaimAdviceRequest',
            'kundenportalClaimAdviceResponse' => '\\StructType\\KundenportalClaimAdviceResponse',
            'kundenportalVerzeichnisseRequest' => '\\StructType\\KundenportalVerzeichnisseRequest',
            'kundenportalVerzeichnisseResponse' => '\\StructType\\KundenportalVerzeichnisseResponse',
            'kundenportalDataRequest' => '\\StructType\\KundenportalDataRequest',
            'kundenportalDataResponse' => '\\StructType\\KundenportalDataResponse',
            'kundenportalSendMessageRequest' => '\\StructType\\KundenportalSendMessageRequest',
            'kundenportalSendMessageResponse' => '\\StructType\\KundenportalSendMessageResponse',
            'kundenportalSchliessfachRequest' => '\\StructType\\KundenportalSchliessfachRequest',
            'kundenportalSchliessfachResponse' => '\\StructType\\KundenportalSchliessfachResponse',
            'kundenportalAddUpdateOrDeleteSchliessfachEintragRequest' => '\\StructType\\KundenportalAddUpdateOrDeleteSchliessfachEintragRequest',
            'kundenportalAddUpdateOrDeleteSchliessfachEintragResponse' => '\\StructType\\KundenportalAddUpdateOrDeleteSchliessfachEintragResponse',
            'kundenportalSetAdvisorRequest' => '\\StructType\\KundenportalSetAdvisorRequest',
            'kundenportalSetAdvisorResponse' => '\\StructType\\KundenportalSetAdvisorResponse',
            'kundenportalRegisterRequest' => '\\StructType\\KundenportalRegisterRequest',
            'kundenportalRegisterResponse' => '\\StructType\\KundenportalRegisterResponse',
            'kundenportalCreateDeleteSaveOrUpdateDocumentRequest' => '\\StructType\\KundenportalCreateDeleteSaveOrUpdateDocumentRequest',
            'kundenportalCreateDeleteSaveOrUpdateDocumentResponse' => '\\StructType\\KundenportalCreateDeleteSaveOrUpdateDocumentResponse',
            'kundenportalGetDocumentRequest' => '\\StructType\\KundenportalGetDocumentRequest',
            'kundenportalGetDocumentResponse' => '\\StructType\\KundenportalGetDocumentResponse',
            'kundenportalResendActivationLinkRequest' => '\\StructType\\KundenportalResendActivationLinkRequest',
            'kundenportalResendActivationLinkResponse' => '\\StructType\\KundenportalResendActivationLinkResponse',
            'kundenportalActivationRequest' => '\\StructType\\KundenportalActivationRequest',
            'kundenportalActivationResponse' => '\\StructType\\KundenportalActivationResponse',
            'kundenportalPushNachrichtRequest' => '\\StructType\\KundenportalPushNachrichtRequest',
            'kundenportalPushNachrichtResponse' => '\\StructType\\KundenportalPushNachrichtResponse',
            'kundenportalMarkMessageAsReadRequest' => '\\StructType\\KundenportalMarkMessageAsReadRequest',
            'kundenportalMarkMessageAsReadResponse' => '\\StructType\\KundenportalMarkMessageAsReadResponse',
            'kundenportalNewsletterEmailsRequest' => '\\StructType\\KundenportalNewsletterEmailsRequest',
            'kundenportalNewsletterEmailsResponse' => '\\StructType\\KundenportalNewsletterEmailsResponse',
            'kundenportalAntragZustimmenRequest' => '\\StructType\\KundenportalAntragZustimmenRequest',
            'kundenportalAntragZustimmenResponse' => '\\StructType\\KundenportalAntragZustimmenResponse',
            'resetUserNewsletterRequest' => '\\StructType\\ResetUserNewsletterRequest',
            'resetUserNewsletterResponse' => '\\StructType\\ResetUserNewsletterResponse',
            'resetUserPasswordRequest' => '\\StructType\\ResetUserPasswordRequest',
            'resetUserPasswordResponse' => '\\StructType\\ResetUserPasswordResponse',
            'resetUserPasswordQuestionAnswerRequest' => '\\StructType\\ResetUserPasswordQuestionAnswerRequest',
            'resetUserPasswordQuestionAnswerResponse' => '\\StructType\\ResetUserPasswordQuestionAnswerResponse',
            'registerUserRequest' => '\\StructType\\RegisterUserRequest',
            'registerUserResponse' => '\\StructType\\RegisterUserResponse',
            'SchliessfachEintrag' => '\\StructType\\SchliessfachEintrag',
            'BehandlerVZ' => '\\StructType\\BehandlerVZ',
            'BehandlerArtKP' => '\\StructType\\BehandlerArtKP',
            'CommonData' => '\\StructType\\CommonData',
            'TreatmentBill' => '\\StructType\\TreatmentBill',
            'kundenPortalClaimAdviceInitial' => '\\StructType\\KundenPortalClaimAdviceInitial',
            'kundenPortalClaimAdvice' => '\\StructType\\KundenPortalClaimAdvice',
            'propertyInsurance' => '\\StructType\\PropertyInsurance',
            'carInsurance' => '\\StructType\\CarInsurance',
            'driver' => '\\StructType\\Driver',
            'who' => '\\StructType\\Who',
            'damagedCar' => '\\StructType\\DamagedCar',
            'accidentInsurance' => '\\StructType\\AccidentInsurance',
            'healthInsurance' => '\\StructType\\HealthInsurance',
            'stationary' => '\\StructType\\Stationary',
            'ambulant' => '\\StructType\\Ambulant',
        );
    }
}
