<?php

namespace EnumType;

/**
 * This class stands for AdvisorType EnumType
 * @subpackage Enumerations
 */
class AdvisorType
{
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - id: Neutral
     * @return string '1'
     */
    const ENUM_VALUE_0 = '1';
    /**
     * Constant for value '2'
     * Meta information extracted from the WSDL
     * - id: Angestellter
     * @return string '2'
     */
    const ENUM_VALUE_1 = '2';
    /**
     * Constant for value '3'
     * Meta information extracted from the WSDL
     * - id: KonzernAgent
     * @return string '3'
     */
    const ENUM_VALUE_2 = '3';
    /**
     * Constant for value '6'
     * Meta information extracted from the WSDL
     * - id: DVAG
     * @return string '6'
     */
    const ENUM_VALUE_3 = '6';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @uses self::ENUM_VALUE_3
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
            self::ENUM_VALUE_3,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
