<?php

namespace EnumType;

/**
 * This class stands for kasko EnumType
 * @subpackage Enumerations
 */
class Kasko
{
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - id: VBKaskoKeine
     * @return string '1'
     */
    const ENUM_VALUE_0 = '1';
    /**
     * Constant for value '2'
     * Meta information extracted from the WSDL
     * - id: VBKaskoTeilkasko
     * @return string '2'
     */
    const ENUM_VALUE_1 = '2';
    /**
     * Constant for value '3'
     * Meta information extracted from the WSDL
     * - id: VBKaskoParkschaden
     * @return string '3'
     */
    const ENUM_VALUE_2 = '3';
    /**
     * Constant for value '4'
     * Meta information extracted from the WSDL
     * - id: VBKaskoVollkasko
     * @return string '4'
     */
    const ENUM_VALUE_3 = '4';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @uses self::ENUM_VALUE_3
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
            self::ENUM_VALUE_3,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
