<?php

namespace EnumType;

/**
 * This class stands for risikoVorschaedenType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Wurden die Gebäude/der Wohnungsinhalt/Keller in den letzten 7 Jahren durch Hochwasser, Überschwemmung, Muren oder Lawinen beschädigt?
 * @subpackage Enumerations
 */
class RisikoVorschaedenType
{
    /**
     * Constant for value 'keine Vorschäden'
     * @return string 'keine Vorschäden'
     */
    const ENUM_VALUE_0 = 'keine Vorschäden';
    /**
     * Constant for value 'ein Vorschaden'
     * @return string 'ein Vorschaden'
     */
    const ENUM_VALUE_1 = 'ein Vorschaden';
    /**
     * Constant for value 'mehr als ein Vorschaden'
     * @return string 'mehr als ein Vorschaden'
     */
    const ENUM_VALUE_2 = 'mehr als ein Vorschaden';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
