<?php

namespace EnumType;

/**
 * This class stands for sektionType EnumType
 * @subpackage Enumerations
 */
class SektionType
{
    /**
     * Constant for value '1'
     * @return string '1'
     */
    const ENUM_VALUE_0 = '1';
    /**
     * Constant for value '4'
     * @return string '4'
     */
    const ENUM_VALUE_1 = '4';
    /**
     * Constant for value '6'
     * @return string '6'
     */
    const ENUM_VALUE_2 = '6';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
