<?php

namespace EnumType;

/**
 * This class stands for socialInsuranceAuthority EnumType
 * Meta information extracted from the WSDL
 * - documentation: Sozialversicherungsanstalt 1..ASVG 2..BVA 3..SVA Geldleistung 4..SVA Sachleistung 5..Bauern 9..Keine 6..ASVG ähnlich 7..BVA ähnlich 8..EU Sozialversicherung 10..Sozialversicherung außerhalb EU 11..Genzgänger 12..KFA
 * Oberösterreich 13..SVA Geldleistung im Krankenhaus
 * @subpackage Enumerations
 */
class SocialInsuranceAuthority
{
    /**
     * Constant for value '1'
     * @return string '1'
     */
    const ENUM_VALUE_0 = '1';
    /**
     * Constant for value '2'
     * @return string '2'
     */
    const ENUM_VALUE_1 = '2';
    /**
     * Constant for value '3'
     * @return string '3'
     */
    const ENUM_VALUE_2 = '3';
    /**
     * Constant for value '4'
     * @return string '4'
     */
    const ENUM_VALUE_3 = '4';
    /**
     * Constant for value '5'
     * @return string '5'
     */
    const ENUM_VALUE_4 = '5';
    /**
     * Constant for value '6'
     * @return string '6'
     */
    const ENUM_VALUE_5 = '6';
    /**
     * Constant for value '7'
     * @return string '7'
     */
    const ENUM_VALUE_6 = '7';
    /**
     * Constant for value '8'
     * @return string '8'
     */
    const ENUM_VALUE_7 = '8';
    /**
     * Constant for value '9'
     * @return string '9'
     */
    const ENUM_VALUE_8 = '9';
    /**
     * Constant for value '10'
     * @return string '10'
     */
    const ENUM_VALUE_9 = '10';
    /**
     * Constant for value '11'
     * @return string '11'
     */
    const ENUM_VALUE_10 = '11';
    /**
     * Constant for value '12'
     * @return string '12'
     */
    const ENUM_VALUE_11 = '12';
    /**
     * Constant for value '13'
     * @return string '13'
     */
    const ENUM_VALUE_12 = '13';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @uses self::ENUM_VALUE_3
     * @uses self::ENUM_VALUE_4
     * @uses self::ENUM_VALUE_5
     * @uses self::ENUM_VALUE_6
     * @uses self::ENUM_VALUE_7
     * @uses self::ENUM_VALUE_8
     * @uses self::ENUM_VALUE_9
     * @uses self::ENUM_VALUE_10
     * @uses self::ENUM_VALUE_11
     * @uses self::ENUM_VALUE_12
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
            self::ENUM_VALUE_3,
            self::ENUM_VALUE_4,
            self::ENUM_VALUE_5,
            self::ENUM_VALUE_6,
            self::ENUM_VALUE_7,
            self::ENUM_VALUE_8,
            self::ENUM_VALUE_9,
            self::ENUM_VALUE_10,
            self::ENUM_VALUE_11,
            self::ENUM_VALUE_12,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
