<?php

namespace EnumType;

/**
 * This class stands for StornoStatus EnumType
 * @subpackage Enumerations
 */
class StornoStatus
{
    /**
     * Constant for value '0'
     * Meta information extracted from the WSDL
     * - id: StornoStatusUnveraendert
     * @return string '0'
     */
    const ENUM_VALUE_0 = '0';
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - id: StornoStatusStorniert
     * @return string '1'
     */
    const ENUM_VALUE_1 = '1';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
