<?php

namespace EnumType;

/**
 * This class stands for typVorlage EnumType
 * Meta information extracted from the WSDL
 * - documentation: Typ des Attachments: 4..Antrag 5..Sepa-Mandat 6..elektronische Kommunikation 7..Basisblatt 8..Gesundheitsfragen 9..Sonstiges
 * @subpackage Enumerations
 */
class TypVorlage
{
    /**
     * Constant for value '4'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageAntrag
     * @return string '4'
     */
    const ENUM_VALUE_0 = '4';
    /**
     * Constant for value '5'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageSepa
     * @return string '5'
     */
    const ENUM_VALUE_1 = '5';
    /**
     * Constant for value '7'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageBasisBlatt
     * @return string '7'
     */
    const ENUM_VALUE_2 = '7';
    /**
     * Constant for value '6'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageElektrKomm
     * @return string '6'
     */
    const ENUM_VALUE_3 = '6';
    /**
     * Constant for value '8'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageGesundheitsfragen
     * @return string '8'
     */
    const ENUM_VALUE_4 = '8';
    /**
     * Constant for value '9'
     * Meta information extracted from the WSDL
     * - id: AttachmentTypVorlageSonstiges
     * @return string '9'
     */
    const ENUM_VALUE_5 = '9';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::ENUM_VALUE_0
     * @uses self::ENUM_VALUE_1
     * @uses self::ENUM_VALUE_2
     * @uses self::ENUM_VALUE_3
     * @uses self::ENUM_VALUE_4
     * @uses self::ENUM_VALUE_5
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::ENUM_VALUE_0,
            self::ENUM_VALUE_1,
            self::ENUM_VALUE_2,
            self::ENUM_VALUE_3,
            self::ENUM_VALUE_4,
            self::ENUM_VALUE_5,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
