<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for addStateHistoryEntryRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Fügt einen Eintrag zu einem GF in der Statushistorie hinzu. Request
 * @subpackage Structs
 */
class AddStateHistoryEntryRequest extends AbstractStructBase
{
    /**
     * The login
     * @var \StructType\Login
     */
    public $login;
    /**
     * The history
     * Meta information extracted from the WSDL
     * - documentation: History Eintrag
     * @var \StructType\History
     */
    public $history;
    /**
     * Constructor method for addStateHistoryEntryRequest
     * @uses AddStateHistoryEntryRequest::setLogin()
     * @uses AddStateHistoryEntryRequest::setHistory()
     * @param \StructType\Login $login
     * @param \StructType\History $history
     */
    public function __construct(\StructType\Login $login = null, \StructType\History $history = null)
    {
        $this
            ->setLogin($login)
            ->setHistory($history);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\AddStateHistoryEntryRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get history value
     * @return \StructType\History|null
     */
    public function getHistory()
    {
        return $this->history;
    }
    /**
     * Set history value
     * @param \StructType\History $history
     * @return \StructType\AddStateHistoryEntryRequest
     */
    public function setHistory(\StructType\History $history = null)
    {
        $this->history = $history;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddStateHistoryEntryRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
