<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for additionalContractData StructType
 * Meta information extracted from the WSDL
 * - documentation: Zusaetzliche Vertragsdaten
 * @subpackage Structs
 */
class AdditionalContractData extends AbstractStructBase
{
    /**
     * The claimsRatio
     * Meta information extracted from the WSDL
     * - documentation: Gewerbe Konvertierungsrabatt
     * - minOccurs: 0
     * @var float
     */
    public $claimsRatio;
    /**
     * Constructor method for additionalContractData
     * @uses AdditionalContractData::setClaimsRatio()
     * @param float $claimsRatio
     */
    public function __construct($claimsRatio = null)
    {
        $this
            ->setClaimsRatio($claimsRatio);
    }
    /**
     * Get claimsRatio value
     * @return float|null
     */
    public function getClaimsRatio()
    {
        return $this->claimsRatio;
    }
    /**
     * Set claimsRatio value
     * @param float $claimsRatio
     * @return \StructType\AdditionalContractData
     */
    public function setClaimsRatio($claimsRatio = null)
    {
        // validation for constraint: float
        if (!is_null($claimsRatio) && !(is_float($claimsRatio) || is_numeric($claimsRatio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($claimsRatio, true), gettype($claimsRatio)), __LINE__);
        }
        $this->claimsRatio = $claimsRatio;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdditionalContractData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
