<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for attachmentinfoList StructType
 * @subpackage Structs
 */
class AttachmentinfoList extends AbstractStructBase
{
    /**
     * The attachmentinfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\AttachmentinfoType[]
     */
    public $attachmentinfo;
    /**
     * Constructor method for attachmentinfoList
     * @uses AttachmentinfoList::setAttachmentinfo()
     * @param \StructType\AttachmentinfoType[] $attachmentinfo
     */
    public function __construct(array $attachmentinfo = array())
    {
        $this
            ->setAttachmentinfo($attachmentinfo);
    }
    /**
     * Get attachmentinfo value
     * @return \StructType\AttachmentinfoType[]
     */
    public function getAttachmentinfo()
    {
        return $this->attachmentinfo;
    }
    /**
     * This method is responsible for validating the values passed to the setAttachmentinfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAttachmentinfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAttachmentinfoForArrayConstraintsFromSetAttachmentinfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $attachmentinfoListAttachmentinfoItem) {
            // validation for constraint: itemType
            if (!$attachmentinfoListAttachmentinfoItem instanceof \StructType\AttachmentinfoType) {
                $invalidValues[] = is_object($attachmentinfoListAttachmentinfoItem) ? get_class($attachmentinfoListAttachmentinfoItem) : sprintf('%s(%s)', gettype($attachmentinfoListAttachmentinfoItem), var_export($attachmentinfoListAttachmentinfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The attachmentinfo property can only contain items of type \StructType\AttachmentinfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set attachmentinfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AttachmentinfoType[] $attachmentinfo
     * @return \StructType\AttachmentinfoList
     */
    public function setAttachmentinfo(array $attachmentinfo = array())
    {
        // validation for constraint: array
        if ('' !== ($attachmentinfoArrayErrorMessage = self::validateAttachmentinfoForArrayConstraintsFromSetAttachmentinfo($attachmentinfo))) {
            throw new \InvalidArgumentException($attachmentinfoArrayErrorMessage, __LINE__);
        }
        $this->attachmentinfo = $attachmentinfo;
        return $this;
    }
    /**
     * Add item to attachmentinfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AttachmentinfoType $item
     * @return \StructType\AttachmentinfoList
     */
    public function addToAttachmentinfo(\StructType\AttachmentinfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AttachmentinfoType) {
            throw new \InvalidArgumentException(sprintf('The attachmentinfo property can only contain items of type \StructType\AttachmentinfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->attachmentinfo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AttachmentinfoList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
