<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for berufsBereichsRechtsschutzType StructType
 * @subpackage Structs
 */
class BerufsBereichsRechtsschutzType extends AbstractStructBase
{
    /**
     * The betriebsart
     * Meta information extracted from the WSDL
     * - documentation: Betriebsart gem. Oberfläche angeben
     * - minOccurs: 0
     * @var string
     */
    public $betriebsart;
    /**
     * The betriebsartHandel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $betriebsartHandel;
    /**
     * The betriebsartErzeugungMontage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $betriebsartErzeugungMontage;
    /**
     * The rechtsberatungSchadenersatzStrafSozialversicherungsRS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rechtsberatungSchadenersatzStrafSozialversicherungsRS;
    /**
     * The allgemeinerVertragsRS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $allgemeinerVertragsRS;
    /**
     * The steuerRS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $steuerRS;
    /**
     * The eigentumMieteRS
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $eigentumMieteRS;
    /**
     * The anzahlBetriebsobjekte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $anzahlBetriebsobjekte;
    /**
     * Constructor method for berufsBereichsRechtsschutzType
     * @uses BerufsBereichsRechtsschutzType::setBetriebsart()
     * @uses BerufsBereichsRechtsschutzType::setBetriebsartHandel()
     * @uses BerufsBereichsRechtsschutzType::setBetriebsartErzeugungMontage()
     * @uses BerufsBereichsRechtsschutzType::setRechtsberatungSchadenersatzStrafSozialversicherungsRS()
     * @uses BerufsBereichsRechtsschutzType::setAllgemeinerVertragsRS()
     * @uses BerufsBereichsRechtsschutzType::setSteuerRS()
     * @uses BerufsBereichsRechtsschutzType::setEigentumMieteRS()
     * @uses BerufsBereichsRechtsschutzType::setAnzahlBetriebsobjekte()
     * @param string $betriebsart
     * @param string $betriebsartHandel
     * @param string $betriebsartErzeugungMontage
     * @param string $rechtsberatungSchadenersatzStrafSozialversicherungsRS
     * @param string $allgemeinerVertragsRS
     * @param string $steuerRS
     * @param string $eigentumMieteRS
     * @param int $anzahlBetriebsobjekte
     */
    public function __construct($betriebsart = null, $betriebsartHandel = null, $betriebsartErzeugungMontage = null, $rechtsberatungSchadenersatzStrafSozialversicherungsRS = null, $allgemeinerVertragsRS = null, $steuerRS = null, $eigentumMieteRS = null, $anzahlBetriebsobjekte = null)
    {
        $this
            ->setBetriebsart($betriebsart)
            ->setBetriebsartHandel($betriebsartHandel)
            ->setBetriebsartErzeugungMontage($betriebsartErzeugungMontage)
            ->setRechtsberatungSchadenersatzStrafSozialversicherungsRS($rechtsberatungSchadenersatzStrafSozialversicherungsRS)
            ->setAllgemeinerVertragsRS($allgemeinerVertragsRS)
            ->setSteuerRS($steuerRS)
            ->setEigentumMieteRS($eigentumMieteRS)
            ->setAnzahlBetriebsobjekte($anzahlBetriebsobjekte);
    }
    /**
     * Get betriebsart value
     * @return string|null
     */
    public function getBetriebsart()
    {
        return $this->betriebsart;
    }
    /**
     * Set betriebsart value
     * @param string $betriebsart
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setBetriebsart($betriebsart = null)
    {
        // validation for constraint: string
        if (!is_null($betriebsart) && !is_string($betriebsart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($betriebsart, true), gettype($betriebsart)), __LINE__);
        }
        $this->betriebsart = $betriebsart;
        return $this;
    }
    /**
     * Get betriebsartHandel value
     * @return string|null
     */
    public function getBetriebsartHandel()
    {
        return $this->betriebsartHandel;
    }
    /**
     * Set betriebsartHandel value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $betriebsartHandel
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setBetriebsartHandel($betriebsartHandel = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($betriebsartHandel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($betriebsartHandel) ? implode(', ', $betriebsartHandel) : var_export($betriebsartHandel, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->betriebsartHandel = $betriebsartHandel;
        return $this;
    }
    /**
     * Get betriebsartErzeugungMontage value
     * @return string|null
     */
    public function getBetriebsartErzeugungMontage()
    {
        return $this->betriebsartErzeugungMontage;
    }
    /**
     * Set betriebsartErzeugungMontage value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $betriebsartErzeugungMontage
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setBetriebsartErzeugungMontage($betriebsartErzeugungMontage = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($betriebsartErzeugungMontage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($betriebsartErzeugungMontage) ? implode(', ', $betriebsartErzeugungMontage) : var_export($betriebsartErzeugungMontage, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->betriebsartErzeugungMontage = $betriebsartErzeugungMontage;
        return $this;
    }
    /**
     * Get rechtsberatungSchadenersatzStrafSozialversicherungsRS value
     * @return string|null
     */
    public function getRechtsberatungSchadenersatzStrafSozialversicherungsRS()
    {
        return $this->rechtsberatungSchadenersatzStrafSozialversicherungsRS;
    }
    /**
     * Set rechtsberatungSchadenersatzStrafSozialversicherungsRS value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $rechtsberatungSchadenersatzStrafSozialversicherungsRS
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setRechtsberatungSchadenersatzStrafSozialversicherungsRS($rechtsberatungSchadenersatzStrafSozialversicherungsRS = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($rechtsberatungSchadenersatzStrafSozialversicherungsRS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($rechtsberatungSchadenersatzStrafSozialversicherungsRS) ? implode(', ', $rechtsberatungSchadenersatzStrafSozialversicherungsRS) : var_export($rechtsberatungSchadenersatzStrafSozialversicherungsRS, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->rechtsberatungSchadenersatzStrafSozialversicherungsRS = $rechtsberatungSchadenersatzStrafSozialversicherungsRS;
        return $this;
    }
    /**
     * Get allgemeinerVertragsRS value
     * @return string|null
     */
    public function getAllgemeinerVertragsRS()
    {
        return $this->allgemeinerVertragsRS;
    }
    /**
     * Set allgemeinerVertragsRS value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $allgemeinerVertragsRS
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setAllgemeinerVertragsRS($allgemeinerVertragsRS = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($allgemeinerVertragsRS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($allgemeinerVertragsRS) ? implode(', ', $allgemeinerVertragsRS) : var_export($allgemeinerVertragsRS, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->allgemeinerVertragsRS = $allgemeinerVertragsRS;
        return $this;
    }
    /**
     * Get steuerRS value
     * @return string|null
     */
    public function getSteuerRS()
    {
        return $this->steuerRS;
    }
    /**
     * Set steuerRS value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $steuerRS
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setSteuerRS($steuerRS = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($steuerRS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($steuerRS) ? implode(', ', $steuerRS) : var_export($steuerRS, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->steuerRS = $steuerRS;
        return $this;
    }
    /**
     * Get eigentumMieteRS value
     * @return string|null
     */
    public function getEigentumMieteRS()
    {
        return $this->eigentumMieteRS;
    }
    /**
     * Set eigentumMieteRS value
     * @uses \EnumType\JaNeinType::valueIsValid()
     * @uses \EnumType\JaNeinType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $eigentumMieteRS
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setEigentumMieteRS($eigentumMieteRS = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JaNeinType::valueIsValid($eigentumMieteRS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JaNeinType', is_array($eigentumMieteRS) ? implode(', ', $eigentumMieteRS) : var_export($eigentumMieteRS, true), implode(', ', \EnumType\JaNeinType::getValidValues())), __LINE__);
        }
        $this->eigentumMieteRS = $eigentumMieteRS;
        return $this;
    }
    /**
     * Get anzahlBetriebsobjekte value
     * @return int|null
     */
    public function getAnzahlBetriebsobjekte()
    {
        return $this->anzahlBetriebsobjekte;
    }
    /**
     * Set anzahlBetriebsobjekte value
     * @param int $anzahlBetriebsobjekte
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public function setAnzahlBetriebsobjekte($anzahlBetriebsobjekte = null)
    {
        // validation for constraint: int
        if (!is_null($anzahlBetriebsobjekte) && !(is_int($anzahlBetriebsobjekte) || ctype_digit($anzahlBetriebsobjekte))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($anzahlBetriebsobjekte, true), gettype($anzahlBetriebsobjekte)), __LINE__);
        }
        $this->anzahlBetriebsobjekte = $anzahlBetriebsobjekte;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BerufsBereichsRechtsschutzType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
