<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for browseMessageFromMQRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request getting Message from MQ
 * @subpackage Structs
 */
class BrowseMessageFromMQRequest extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - documentation: login data of user
     * @var \StructType\Login
     */
    public $login;
    /**
     * The andDeleteMessageFromQueue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $andDeleteMessageFromQueue;
    /**
     * Constructor method for browseMessageFromMQRequest
     * @uses BrowseMessageFromMQRequest::setLogin()
     * @uses BrowseMessageFromMQRequest::setAndDeleteMessageFromQueue()
     * @param \StructType\Login $login
     * @param bool $andDeleteMessageFromQueue
     */
    public function __construct(\StructType\Login $login = null, $andDeleteMessageFromQueue = null)
    {
        $this
            ->setLogin($login)
            ->setAndDeleteMessageFromQueue($andDeleteMessageFromQueue);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\BrowseMessageFromMQRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get andDeleteMessageFromQueue value
     * @return bool|null
     */
    public function getAndDeleteMessageFromQueue()
    {
        return $this->andDeleteMessageFromQueue;
    }
    /**
     * Set andDeleteMessageFromQueue value
     * @param bool $andDeleteMessageFromQueue
     * @return \StructType\BrowseMessageFromMQRequest
     */
    public function setAndDeleteMessageFromQueue($andDeleteMessageFromQueue = null)
    {
        // validation for constraint: boolean
        if (!is_null($andDeleteMessageFromQueue) && !is_bool($andDeleteMessageFromQueue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($andDeleteMessageFromQueue, true), gettype($andDeleteMessageFromQueue)), __LINE__);
        }
        $this->andDeleteMessageFromQueue = $andDeleteMessageFromQueue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BrowseMessageFromMQRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
