<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for calculatePremiumOnlyResponse StructType
 * @subpackage Structs
 */
class CalculatePremiumOnlyResponse extends AbstractStructBase
{
    /**
     * The premium
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premium;
    /**
     * The tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tax;
    /**
     * The premiumHaftpflicht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premiumHaftpflicht;
    /**
     * The premiumKasko
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premiumKasko;
    /**
     * The premiumInsassenUnfall
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premiumInsassenUnfall;
    /**
     * The premiumRechtsschutz
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $premiumRechtsschutz;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for calculatePremiumOnlyResponse
     * @uses CalculatePremiumOnlyResponse::setPremium()
     * @uses CalculatePremiumOnlyResponse::setTax()
     * @uses CalculatePremiumOnlyResponse::setPremiumHaftpflicht()
     * @uses CalculatePremiumOnlyResponse::setPremiumKasko()
     * @uses CalculatePremiumOnlyResponse::setPremiumInsassenUnfall()
     * @uses CalculatePremiumOnlyResponse::setPremiumRechtsschutz()
     * @uses CalculatePremiumOnlyResponse::setEvpServiceFault()
     * @param string $premium
     * @param string $tax
     * @param string $premiumHaftpflicht
     * @param string $premiumKasko
     * @param string $premiumInsassenUnfall
     * @param string $premiumRechtsschutz
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct($premium = null, $tax = null, $premiumHaftpflicht = null, $premiumKasko = null, $premiumInsassenUnfall = null, $premiumRechtsschutz = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setPremium($premium)
            ->setTax($tax)
            ->setPremiumHaftpflicht($premiumHaftpflicht)
            ->setPremiumKasko($premiumKasko)
            ->setPremiumInsassenUnfall($premiumInsassenUnfall)
            ->setPremiumRechtsschutz($premiumRechtsschutz)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get premium value
     * @return string|null
     */
    public function getPremium()
    {
        return $this->premium;
    }
    /**
     * Set premium value
     * @param string $premium
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setPremium($premium = null)
    {
        // validation for constraint: string
        if (!is_null($premium) && !is_string($premium)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premium, true), gettype($premium)), __LINE__);
        }
        $this->premium = $premium;
        return $this;
    }
    /**
     * Get tax value
     * @return string|null
     */
    public function getTax()
    {
        return $this->tax;
    }
    /**
     * Set tax value
     * @param string $tax
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setTax($tax = null)
    {
        // validation for constraint: string
        if (!is_null($tax) && !is_string($tax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tax, true), gettype($tax)), __LINE__);
        }
        $this->tax = $tax;
        return $this;
    }
    /**
     * Get premiumHaftpflicht value
     * @return string|null
     */
    public function getPremiumHaftpflicht()
    {
        return $this->premiumHaftpflicht;
    }
    /**
     * Set premiumHaftpflicht value
     * @param string $premiumHaftpflicht
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setPremiumHaftpflicht($premiumHaftpflicht = null)
    {
        // validation for constraint: string
        if (!is_null($premiumHaftpflicht) && !is_string($premiumHaftpflicht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premiumHaftpflicht, true), gettype($premiumHaftpflicht)), __LINE__);
        }
        $this->premiumHaftpflicht = $premiumHaftpflicht;
        return $this;
    }
    /**
     * Get premiumKasko value
     * @return string|null
     */
    public function getPremiumKasko()
    {
        return $this->premiumKasko;
    }
    /**
     * Set premiumKasko value
     * @param string $premiumKasko
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setPremiumKasko($premiumKasko = null)
    {
        // validation for constraint: string
        if (!is_null($premiumKasko) && !is_string($premiumKasko)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premiumKasko, true), gettype($premiumKasko)), __LINE__);
        }
        $this->premiumKasko = $premiumKasko;
        return $this;
    }
    /**
     * Get premiumInsassenUnfall value
     * @return string|null
     */
    public function getPremiumInsassenUnfall()
    {
        return $this->premiumInsassenUnfall;
    }
    /**
     * Set premiumInsassenUnfall value
     * @param string $premiumInsassenUnfall
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setPremiumInsassenUnfall($premiumInsassenUnfall = null)
    {
        // validation for constraint: string
        if (!is_null($premiumInsassenUnfall) && !is_string($premiumInsassenUnfall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premiumInsassenUnfall, true), gettype($premiumInsassenUnfall)), __LINE__);
        }
        $this->premiumInsassenUnfall = $premiumInsassenUnfall;
        return $this;
    }
    /**
     * Get premiumRechtsschutz value
     * @return string|null
     */
    public function getPremiumRechtsschutz()
    {
        return $this->premiumRechtsschutz;
    }
    /**
     * Set premiumRechtsschutz value
     * @param string $premiumRechtsschutz
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setPremiumRechtsschutz($premiumRechtsschutz = null)
    {
        // validation for constraint: string
        if (!is_null($premiumRechtsschutz) && !is_string($premiumRechtsschutz)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($premiumRechtsschutz, true), gettype($premiumRechtsschutz)), __LINE__);
        }
        $this->premiumRechtsschutz = $premiumRechtsschutz;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CalculatePremiumOnlyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
