<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createPartnerGroupResponse StructType
 * @subpackage Structs
 */
class CreatePartnerGroupResponse extends AbstractStructBase
{
    /**
     * The httpActionLink
     * Meta information extracted from the WSDL
     * - documentation: http-Link for eVP including the sessionID
     * - minOccurs: 0
     * @var string
     */
    public $httpActionLink;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for createPartnerGroupResponse
     * @uses CreatePartnerGroupResponse::setHttpActionLink()
     * @uses CreatePartnerGroupResponse::setEvpServiceFault()
     * @param string $httpActionLink
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct($httpActionLink = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setHttpActionLink($httpActionLink)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get httpActionLink value
     * @return string|null
     */
    public function getHttpActionLink()
    {
        return $this->httpActionLink;
    }
    /**
     * Set httpActionLink value
     * @param string $httpActionLink
     * @return \StructType\CreatePartnerGroupResponse
     */
    public function setHttpActionLink($httpActionLink = null)
    {
        // validation for constraint: string
        if (!is_null($httpActionLink) && !is_string($httpActionLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($httpActionLink, true), gettype($httpActionLink)), __LINE__);
        }
        $this->httpActionLink = $httpActionLink;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\CreatePartnerGroupResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreatePartnerGroupResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
