<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deckungProzentType StructType
 * @subpackage Structs
 */
class DeckungProzentType extends AbstractStructBase
{
    /**
     * The deckungActive
     * @var bool
     */
    public $deckungActive;
    /**
     * The deckungProzent
     * Meta information extracted from the WSDL
     * - documentation: Wenn der Prozentwert eine Auswahlliste ist, wird der übergebene Wert in der Liste gesucht - falls nicht vorhanden bleibt der Standardwert selektiert.
     * @var int
     */
    public $deckungProzent;
    /**
     * Constructor method for deckungProzentType
     * @uses DeckungProzentType::setDeckungActive()
     * @uses DeckungProzentType::setDeckungProzent()
     * @param bool $deckungActive
     * @param int $deckungProzent
     */
    public function __construct($deckungActive = null, $deckungProzent = null)
    {
        $this
            ->setDeckungActive($deckungActive)
            ->setDeckungProzent($deckungProzent);
    }
    /**
     * Get deckungActive value
     * @return bool|null
     */
    public function getDeckungActive()
    {
        return $this->deckungActive;
    }
    /**
     * Set deckungActive value
     * @param bool $deckungActive
     * @return \StructType\DeckungProzentType
     */
    public function setDeckungActive($deckungActive = null)
    {
        // validation for constraint: boolean
        if (!is_null($deckungActive) && !is_bool($deckungActive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deckungActive, true), gettype($deckungActive)), __LINE__);
        }
        $this->deckungActive = $deckungActive;
        return $this;
    }
    /**
     * Get deckungProzent value
     * @return int|null
     */
    public function getDeckungProzent()
    {
        return $this->deckungProzent;
    }
    /**
     * Set deckungProzent value
     * @param int $deckungProzent
     * @return \StructType\DeckungProzentType
     */
    public function setDeckungProzent($deckungProzent = null)
    {
        // validation for constraint: int
        if (!is_null($deckungProzent) && !(is_int($deckungProzent) || ctype_digit($deckungProzent))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($deckungProzent, true), gettype($deckungProzent)), __LINE__);
        }
        $this->deckungProzent = $deckungProzent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeckungProzentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
