<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deckungVsType StructType
 * @subpackage Structs
 */
class DeckungVsType extends AbstractStructBase
{
    /**
     * The deckungActive
     * @var bool
     */
    public $deckungActive;
    /**
     * The deckungVs
     * Meta information extracted from the WSDL
     * - documentation: Wenn die Versicherungssumme eine Auswahlliste ist, wird der übergebene Wert in der Liste gesucht - falls nicht vorhanden bleibt der Standardwert selektiert.
     * @var int
     */
    public $deckungVs;
    /**
     * Constructor method for deckungVsType
     * @uses DeckungVsType::setDeckungActive()
     * @uses DeckungVsType::setDeckungVs()
     * @param bool $deckungActive
     * @param int $deckungVs
     */
    public function __construct($deckungActive = null, $deckungVs = null)
    {
        $this
            ->setDeckungActive($deckungActive)
            ->setDeckungVs($deckungVs);
    }
    /**
     * Get deckungActive value
     * @return bool|null
     */
    public function getDeckungActive()
    {
        return $this->deckungActive;
    }
    /**
     * Set deckungActive value
     * @param bool $deckungActive
     * @return \StructType\DeckungVsType
     */
    public function setDeckungActive($deckungActive = null)
    {
        // validation for constraint: boolean
        if (!is_null($deckungActive) && !is_bool($deckungActive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deckungActive, true), gettype($deckungActive)), __LINE__);
        }
        $this->deckungActive = $deckungActive;
        return $this;
    }
    /**
     * Get deckungVs value
     * @return int|null
     */
    public function getDeckungVs()
    {
        return $this->deckungVs;
    }
    /**
     * Set deckungVs value
     * @param int $deckungVs
     * @return \StructType\DeckungVsType
     */
    public function setDeckungVs($deckungVs = null)
    {
        // validation for constraint: int
        if (!is_null($deckungVs) && !(is_int($deckungVs) || ctype_digit($deckungVs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($deckungVs, true), gettype($deckungVs)), __LINE__);
        }
        $this->deckungVs = $deckungVs;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeckungVsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
