<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deleteUserDataTokensResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response zum User Token löschen
 * @subpackage Structs
 */
class DeleteUserDataTokensResponse extends AbstractStructBase
{
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * The userId
     * @var mixed
     */
    public $userId;
    /**
     * The message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The userTokens
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UserToken[]
     */
    public $userTokens;
    /**
     * Constructor method for deleteUserDataTokensResponse
     * @uses DeleteUserDataTokensResponse::setEvpServiceFault()
     * @uses DeleteUserDataTokensResponse::setUserId()
     * @uses DeleteUserDataTokensResponse::setMessage()
     * @uses DeleteUserDataTokensResponse::setUserTokens()
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @param mixed $userId
     * @param string $message
     * @param \StructType\UserToken[] $userTokens
     */
    public function __construct(\StructType\EvpServiceFault $evpServiceFault = null, $userId = null, $message = null, array $userTokens = array())
    {
        $this
            ->setEvpServiceFault($evpServiceFault)
            ->setUserId($userId)
            ->setMessage($message)
            ->setUserTokens($userTokens);
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Get userId value
     * @return mixed|null
     */
    public function getUserId()
    {
        return $this->userId;
    }
    /**
     * Set userId value
     * @param mixed $userId
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public function setUserId($userId = null)
    {
        $this->userId = $userId;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get userTokens value
     * @return \StructType\UserToken[]|null
     */
    public function getUserTokens()
    {
        return $this->userTokens;
    }
    /**
     * This method is responsible for validating the values passed to the setUserTokens method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserTokens method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserTokensForArrayConstraintsFromSetUserTokens(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $deleteUserDataTokensResponseUserTokensItem) {
            // validation for constraint: itemType
            if (!$deleteUserDataTokensResponseUserTokensItem instanceof \StructType\UserToken) {
                $invalidValues[] = is_object($deleteUserDataTokensResponseUserTokensItem) ? get_class($deleteUserDataTokensResponseUserTokensItem) : sprintf('%s(%s)', gettype($deleteUserDataTokensResponseUserTokensItem), var_export($deleteUserDataTokensResponseUserTokensItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The userTokens property can only contain items of type \StructType\UserToken, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set userTokens value
     * @throws \InvalidArgumentException
     * @param \StructType\UserToken[] $userTokens
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public function setUserTokens(array $userTokens = array())
    {
        // validation for constraint: array
        if ('' !== ($userTokensArrayErrorMessage = self::validateUserTokensForArrayConstraintsFromSetUserTokens($userTokens))) {
            throw new \InvalidArgumentException($userTokensArrayErrorMessage, __LINE__);
        }
        $this->userTokens = $userTokens;
        return $this;
    }
    /**
     * Add item to userTokens value
     * @throws \InvalidArgumentException
     * @param \StructType\UserToken $item
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public function addToUserTokens(\StructType\UserToken $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UserToken) {
            throw new \InvalidArgumentException(sprintf('The userTokens property can only contain items of type \StructType\UserToken, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->userTokens[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeleteUserDataTokensResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
