<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for driver StructType
 * @subpackage Structs
 */
class Driver extends AbstractStructBase
{
    /**
     * The who
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Who
     */
    public $who;
    /**
     * The alcohol
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $alcohol;
    /**
     * The driverLicenseData
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $driverLicenseData;
    /**
     * The claimant
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClaimentPerson
     */
    public $claimant;
    /**
     * The furterClaimants
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $furterClaimants;
    /**
     * The damagedCar
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DamagedCar
     */
    public $damagedCar;
    /**
     * The furtherCars
     * Meta information extracted from the WSDL
     * - choice: who | alcohol | driverLicenseData | claimant | furterClaimants | damagedCar | furtherCars
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $furtherCars;
    /**
     * Constructor method for driver
     * @uses Driver::setWho()
     * @uses Driver::setAlcohol()
     * @uses Driver::setDriverLicenseData()
     * @uses Driver::setClaimant()
     * @uses Driver::setFurterClaimants()
     * @uses Driver::setDamagedCar()
     * @uses Driver::setFurtherCars()
     * @param \StructType\Who $who
     * @param mixed $alcohol
     * @param mixed $driverLicenseData
     * @param \StructType\ClaimentPerson $claimant
     * @param mixed $furterClaimants
     * @param \StructType\DamagedCar $damagedCar
     * @param string $furtherCars
     */
    public function __construct(\StructType\Who $who = null, $alcohol = null, $driverLicenseData = null, \StructType\ClaimentPerson $claimant = null, $furterClaimants = null, \StructType\DamagedCar $damagedCar = null, $furtherCars = null)
    {
        $this
            ->setWho($who)
            ->setAlcohol($alcohol)
            ->setDriverLicenseData($driverLicenseData)
            ->setClaimant($claimant)
            ->setFurterClaimants($furterClaimants)
            ->setDamagedCar($damagedCar)
            ->setFurtherCars($furtherCars);
    }
    /**
     * Get who value
     * @return \StructType\Who|null
     */
    public function getWho()
    {
        return isset($this->who) ? $this->who : null;
    }
    /**
     * This method is responsible for validating the value passed to the setWho method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWho method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateWhoForChoiceConstraintsFromSetWho($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'alcohol',
            'driverLicenseData',
            'claimant',
            'furterClaimants',
            'damagedCar',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property who can\'t be set as the property %s is already set. Only one property must be set among these properties: who, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set who value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Who $who
     * @return \StructType\Driver
     */
    public function setWho(\StructType\Who $who = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($whoChoiceErrorMessage = self::validateWhoForChoiceConstraintsFromSetWho($who))) {
            throw new \InvalidArgumentException($whoChoiceErrorMessage, __LINE__);
        }
        if (is_null($who) || (is_array($who) && empty($who))) {
            unset($this->who);
        } else {
            $this->who = $who;
        }
        return $this;
    }
    /**
     * Get alcohol value
     * @return mixed|null
     */
    public function getAlcohol()
    {
        return isset($this->alcohol) ? $this->alcohol : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAlcohol method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlcohol method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAlcoholForChoiceConstraintsFromSetAlcohol($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'driverLicenseData',
            'claimant',
            'furterClaimants',
            'damagedCar',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property alcohol can\'t be set as the property %s is already set. Only one property must be set among these properties: alcohol, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set alcohol value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $alcohol
     * @return \StructType\Driver
     */
    public function setAlcohol($alcohol = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($alcoholChoiceErrorMessage = self::validateAlcoholForChoiceConstraintsFromSetAlcohol($alcohol))) {
            throw new \InvalidArgumentException($alcoholChoiceErrorMessage, __LINE__);
        }
        if (is_null($alcohol) || (is_array($alcohol) && empty($alcohol))) {
            unset($this->alcohol);
        } else {
            $this->alcohol = $alcohol;
        }
        return $this;
    }
    /**
     * Get driverLicenseData value
     * @return mixed|null
     */
    public function getDriverLicenseData()
    {
        return isset($this->driverLicenseData) ? $this->driverLicenseData : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDriverLicenseData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDriverLicenseData method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDriverLicenseDataForChoiceConstraintsFromSetDriverLicenseData($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'alcohol',
            'claimant',
            'furterClaimants',
            'damagedCar',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property driverLicenseData can\'t be set as the property %s is already set. Only one property must be set among these properties: driverLicenseData, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set driverLicenseData value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $driverLicenseData
     * @return \StructType\Driver
     */
    public function setDriverLicenseData($driverLicenseData = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($driverLicenseDataChoiceErrorMessage = self::validateDriverLicenseDataForChoiceConstraintsFromSetDriverLicenseData($driverLicenseData))) {
            throw new \InvalidArgumentException($driverLicenseDataChoiceErrorMessage, __LINE__);
        }
        if (is_null($driverLicenseData) || (is_array($driverLicenseData) && empty($driverLicenseData))) {
            unset($this->driverLicenseData);
        } else {
            $this->driverLicenseData = $driverLicenseData;
        }
        return $this;
    }
    /**
     * Get claimant value
     * @return \StructType\ClaimentPerson|null
     */
    public function getClaimant()
    {
        return isset($this->claimant) ? $this->claimant : null;
    }
    /**
     * This method is responsible for validating the value passed to the setClaimant method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClaimant method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateClaimantForChoiceConstraintsFromSetClaimant($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'alcohol',
            'driverLicenseData',
            'furterClaimants',
            'damagedCar',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property claimant can\'t be set as the property %s is already set. Only one property must be set among these properties: claimant, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set claimant value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClaimentPerson $claimant
     * @return \StructType\Driver
     */
    public function setClaimant(\StructType\ClaimentPerson $claimant = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($claimantChoiceErrorMessage = self::validateClaimantForChoiceConstraintsFromSetClaimant($claimant))) {
            throw new \InvalidArgumentException($claimantChoiceErrorMessage, __LINE__);
        }
        if (is_null($claimant) || (is_array($claimant) && empty($claimant))) {
            unset($this->claimant);
        } else {
            $this->claimant = $claimant;
        }
        return $this;
    }
    /**
     * Get furterClaimants value
     * @return mixed|null
     */
    public function getFurterClaimants()
    {
        return isset($this->furterClaimants) ? $this->furterClaimants : null;
    }
    /**
     * This method is responsible for validating the value passed to the setFurterClaimants method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFurterClaimants method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateFurterClaimantsForChoiceConstraintsFromSetFurterClaimants($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'alcohol',
            'driverLicenseData',
            'claimant',
            'damagedCar',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property furterClaimants can\'t be set as the property %s is already set. Only one property must be set among these properties: furterClaimants, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set furterClaimants value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $furterClaimants
     * @return \StructType\Driver
     */
    public function setFurterClaimants($furterClaimants = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($furterClaimantsChoiceErrorMessage = self::validateFurterClaimantsForChoiceConstraintsFromSetFurterClaimants($furterClaimants))) {
            throw new \InvalidArgumentException($furterClaimantsChoiceErrorMessage, __LINE__);
        }
        if (is_null($furterClaimants) || (is_array($furterClaimants) && empty($furterClaimants))) {
            unset($this->furterClaimants);
        } else {
            $this->furterClaimants = $furterClaimants;
        }
        return $this;
    }
    /**
     * Get damagedCar value
     * @return \StructType\DamagedCar|null
     */
    public function getDamagedCar()
    {
        return isset($this->damagedCar) ? $this->damagedCar : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDamagedCar method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDamagedCar method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDamagedCarForChoiceConstraintsFromSetDamagedCar($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'alcohol',
            'driverLicenseData',
            'claimant',
            'furterClaimants',
            'furtherCars',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property damagedCar can\'t be set as the property %s is already set. Only one property must be set among these properties: damagedCar, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set damagedCar value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DamagedCar $damagedCar
     * @return \StructType\Driver
     */
    public function setDamagedCar(\StructType\DamagedCar $damagedCar = null)
    {
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($damagedCarChoiceErrorMessage = self::validateDamagedCarForChoiceConstraintsFromSetDamagedCar($damagedCar))) {
            throw new \InvalidArgumentException($damagedCarChoiceErrorMessage, __LINE__);
        }
        if (is_null($damagedCar) || (is_array($damagedCar) && empty($damagedCar))) {
            unset($this->damagedCar);
        } else {
            $this->damagedCar = $damagedCar;
        }
        return $this;
    }
    /**
     * Get furtherCars value
     * @return string|null
     */
    public function getFurtherCars()
    {
        return isset($this->furtherCars) ? $this->furtherCars : null;
    }
    /**
     * This method is responsible for validating the value passed to the setFurtherCars method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFurtherCars method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateFurtherCarsForChoiceConstraintsFromSetFurtherCars($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'who',
            'alcohol',
            'driverLicenseData',
            'claimant',
            'furterClaimants',
            'damagedCar',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property furtherCars can\'t be set as the property %s is already set. Only one property must be set among these properties: furtherCars, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set furtherCars value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param string $furtherCars
     * @return \StructType\Driver
     */
    public function setFurtherCars($furtherCars = null)
    {
        // validation for constraint: string
        if (!is_null($furtherCars) && !is_string($furtherCars)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($furtherCars, true), gettype($furtherCars)), __LINE__);
        }
        // validation for constraint: choice(who, alcohol, driverLicenseData, claimant, furterClaimants, damagedCar, furtherCars)
        if ('' !== ($furtherCarsChoiceErrorMessage = self::validateFurtherCarsForChoiceConstraintsFromSetFurtherCars($furtherCars))) {
            throw new \InvalidArgumentException($furtherCarsChoiceErrorMessage, __LINE__);
        }
        if (is_null($furtherCars) || (is_array($furtherCars) && empty($furtherCars))) {
            unset($this->furtherCars);
        } else {
            $this->furtherCars = $furtherCars;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Driver
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
