<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getArcImageInfosResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response zum Abruf der Informationen der Dokumente zu einer Polizze aus dem Generali ArchivClient
 * @subpackage Structs
 */
class GetArcImageInfosResponse extends AbstractStructBase
{
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * The arcImageInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ArcImageInfo[]
     */
    public $arcImageInfo;
    /**
     * Constructor method for getArcImageInfosResponse
     * @uses GetArcImageInfosResponse::setEvpServiceFault()
     * @uses GetArcImageInfosResponse::setArcImageInfo()
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @param \StructType\ArcImageInfo[] $arcImageInfo
     */
    public function __construct(\StructType\EvpServiceFault $evpServiceFault = null, array $arcImageInfo = array())
    {
        $this
            ->setEvpServiceFault($evpServiceFault)
            ->setArcImageInfo($arcImageInfo);
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetArcImageInfosResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Get arcImageInfo value
     * @return \StructType\ArcImageInfo[]|null
     */
    public function getArcImageInfo()
    {
        return $this->arcImageInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setArcImageInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArcImageInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArcImageInfoForArrayConstraintsFromSetArcImageInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getArcImageInfosResponseArcImageInfoItem) {
            // validation for constraint: itemType
            if (!$getArcImageInfosResponseArcImageInfoItem instanceof \StructType\ArcImageInfo) {
                $invalidValues[] = is_object($getArcImageInfosResponseArcImageInfoItem) ? get_class($getArcImageInfosResponseArcImageInfoItem) : sprintf('%s(%s)', gettype($getArcImageInfosResponseArcImageInfoItem), var_export($getArcImageInfosResponseArcImageInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The arcImageInfo property can only contain items of type \StructType\ArcImageInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set arcImageInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\ArcImageInfo[] $arcImageInfo
     * @return \StructType\GetArcImageInfosResponse
     */
    public function setArcImageInfo(array $arcImageInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($arcImageInfoArrayErrorMessage = self::validateArcImageInfoForArrayConstraintsFromSetArcImageInfo($arcImageInfo))) {
            throw new \InvalidArgumentException($arcImageInfoArrayErrorMessage, __LINE__);
        }
        $this->arcImageInfo = $arcImageInfo;
        return $this;
    }
    /**
     * Add item to arcImageInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\ArcImageInfo $item
     * @return \StructType\GetArcImageInfosResponse
     */
    public function addToArcImageInfo(\StructType\ArcImageInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArcImageInfo) {
            throw new \InvalidArgumentException(sprintf('The arcImageInfo property can only contain items of type \StructType\ArcImageInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->arcImageInfo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetArcImageInfosResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
