<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getArcImageResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response zum Abruf eines Image (Polizze, FA-Bestaetigung) aus dem Generali ArchivClient
 * @subpackage Structs
 */
class GetArcImageResponse extends AbstractStructBase
{
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * The arcContent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ArcContent
     */
    public $arcContent;
    /**
     * Constructor method for getArcImageResponse
     * @uses GetArcImageResponse::setEvpServiceFault()
     * @uses GetArcImageResponse::setArcContent()
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @param \StructType\ArcContent $arcContent
     */
    public function __construct(\StructType\EvpServiceFault $evpServiceFault = null, \StructType\ArcContent $arcContent = null)
    {
        $this
            ->setEvpServiceFault($evpServiceFault)
            ->setArcContent($arcContent);
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetArcImageResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Get arcContent value
     * @return \StructType\ArcContent|null
     */
    public function getArcContent()
    {
        return $this->arcContent;
    }
    /**
     * Set arcContent value
     * @param \StructType\ArcContent $arcContent
     * @return \StructType\GetArcImageResponse
     */
    public function setArcContent(\StructType\ArcContent $arcContent = null)
    {
        $this->arcContent = $arcContent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetArcImageResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
