<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getBerechnungswerteResponse StructType
 * @subpackage Structs
 */
class GetBerechnungswerteResponse extends AbstractStructBase
{
    /**
     * The berechnungswerte
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BerechnungswerteType[]
     */
    public $berechnungswerte;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getBerechnungswerteResponse
     * @uses GetBerechnungswerteResponse::setBerechnungswerte()
     * @uses GetBerechnungswerteResponse::setEvpServiceFault()
     * @param \StructType\BerechnungswerteType[] $berechnungswerte
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $berechnungswerte = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setBerechnungswerte($berechnungswerte)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get berechnungswerte value
     * @return \StructType\BerechnungswerteType[]|null
     */
    public function getBerechnungswerte()
    {
        return $this->berechnungswerte;
    }
    /**
     * This method is responsible for validating the values passed to the setBerechnungswerte method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBerechnungswerte method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBerechnungswerteForArrayConstraintsFromSetBerechnungswerte(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getBerechnungswerteResponseBerechnungswerteItem) {
            // validation for constraint: itemType
            if (!$getBerechnungswerteResponseBerechnungswerteItem instanceof \StructType\BerechnungswerteType) {
                $invalidValues[] = is_object($getBerechnungswerteResponseBerechnungswerteItem) ? get_class($getBerechnungswerteResponseBerechnungswerteItem) : sprintf('%s(%s)', gettype($getBerechnungswerteResponseBerechnungswerteItem), var_export($getBerechnungswerteResponseBerechnungswerteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The berechnungswerte property can only contain items of type \StructType\BerechnungswerteType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set berechnungswerte value
     * @throws \InvalidArgumentException
     * @param \StructType\BerechnungswerteType[] $berechnungswerte
     * @return \StructType\GetBerechnungswerteResponse
     */
    public function setBerechnungswerte(array $berechnungswerte = array())
    {
        // validation for constraint: array
        if ('' !== ($berechnungswerteArrayErrorMessage = self::validateBerechnungswerteForArrayConstraintsFromSetBerechnungswerte($berechnungswerte))) {
            throw new \InvalidArgumentException($berechnungswerteArrayErrorMessage, __LINE__);
        }
        $this->berechnungswerte = $berechnungswerte;
        return $this;
    }
    /**
     * Add item to berechnungswerte value
     * @throws \InvalidArgumentException
     * @param \StructType\BerechnungswerteType $item
     * @return \StructType\GetBerechnungswerteResponse
     */
    public function addToBerechnungswerte(\StructType\BerechnungswerteType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BerechnungswerteType) {
            throw new \InvalidArgumentException(sprintf('The berechnungswerte property can only contain items of type \StructType\BerechnungswerteType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->berechnungswerte[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetBerechnungswerteResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBerechnungswerteResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
