<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getBusinessCaseReadonlyLinkResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Liefert einen Link auf der Readonly des angegebenen Geschäftsfalles
 * @subpackage Structs
 */
class GetBusinessCaseReadonlyLinkResponse extends AbstractStructBase
{
    /**
     * The readonlyLink
     * Meta information extracted from the WSDL
     * - documentation: Link auf die Readonly des Geschäfstfalles
     * - minOccurs: 0
     * @var string
     */
    public $readonlyLink;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getBusinessCaseReadonlyLinkResponse
     * @uses GetBusinessCaseReadonlyLinkResponse::setReadonlyLink()
     * @uses GetBusinessCaseReadonlyLinkResponse::setEvpServiceFault()
     * @param string $readonlyLink
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct($readonlyLink = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setReadonlyLink($readonlyLink)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get readonlyLink value
     * @return string|null
     */
    public function getReadonlyLink()
    {
        return $this->readonlyLink;
    }
    /**
     * Set readonlyLink value
     * @param string $readonlyLink
     * @return \StructType\GetBusinessCaseReadonlyLinkResponse
     */
    public function setReadonlyLink($readonlyLink = null)
    {
        // validation for constraint: string
        if (!is_null($readonlyLink) && !is_string($readonlyLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($readonlyLink, true), gettype($readonlyLink)), __LINE__);
        }
        $this->readonlyLink = $readonlyLink;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetBusinessCaseReadonlyLinkResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBusinessCaseReadonlyLinkResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
