<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getBusinessCollectionDataRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Liefert für eine Polizzennummer, Sektion und Vermittlernummerkombination die Inkassodaten
 * @subpackage Structs
 */
class GetBusinessCollectionDataRequest extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - documentation: login user
     * @var \StructType\Login
     */
    public $login;
    /**
     * The policyData
     * Meta information extracted from the WSDL
     * - documentation: policydata for the contract
     * @var \StructType\Policy
     */
    public $policyData;
    /**
     * Constructor method for getBusinessCollectionDataRequest
     * @uses GetBusinessCollectionDataRequest::setLogin()
     * @uses GetBusinessCollectionDataRequest::setPolicyData()
     * @param \StructType\Login $login
     * @param \StructType\Policy $policyData
     */
    public function __construct(\StructType\Login $login = null, \StructType\Policy $policyData = null)
    {
        $this
            ->setLogin($login)
            ->setPolicyData($policyData);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\GetBusinessCollectionDataRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get policyData value
     * @return \StructType\Policy|null
     */
    public function getPolicyData()
    {
        return $this->policyData;
    }
    /**
     * Set policyData value
     * @param \StructType\Policy $policyData
     * @return \StructType\GetBusinessCollectionDataRequest
     */
    public function setPolicyData(\StructType\Policy $policyData = null)
    {
        $this->policyData = $policyData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBusinessCollectionDataRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
