<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getChoiceListsResponse StructType
 * @subpackage Structs
 */
class GetChoiceListsResponse extends AbstractStructBase
{
    /**
     * The choiceList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ChoiceList[]
     */
    public $choiceList;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getChoiceListsResponse
     * @uses GetChoiceListsResponse::setChoiceList()
     * @uses GetChoiceListsResponse::setEvpServiceFault()
     * @param \StructType\ChoiceList[] $choiceList
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $choiceList = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setChoiceList($choiceList)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get choiceList value
     * @return \StructType\ChoiceList[]|null
     */
    public function getChoiceList()
    {
        return $this->choiceList;
    }
    /**
     * This method is responsible for validating the values passed to the setChoiceList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChoiceList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChoiceListForArrayConstraintsFromSetChoiceList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getChoiceListsResponseChoiceListItem) {
            // validation for constraint: itemType
            if (!$getChoiceListsResponseChoiceListItem instanceof \StructType\ChoiceList) {
                $invalidValues[] = is_object($getChoiceListsResponseChoiceListItem) ? get_class($getChoiceListsResponseChoiceListItem) : sprintf('%s(%s)', gettype($getChoiceListsResponseChoiceListItem), var_export($getChoiceListsResponseChoiceListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The choiceList property can only contain items of type \StructType\ChoiceList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set choiceList value
     * @throws \InvalidArgumentException
     * @param \StructType\ChoiceList[] $choiceList
     * @return \StructType\GetChoiceListsResponse
     */
    public function setChoiceList(array $choiceList = array())
    {
        // validation for constraint: array
        if ('' !== ($choiceListArrayErrorMessage = self::validateChoiceListForArrayConstraintsFromSetChoiceList($choiceList))) {
            throw new \InvalidArgumentException($choiceListArrayErrorMessage, __LINE__);
        }
        $this->choiceList = $choiceList;
        return $this;
    }
    /**
     * Add item to choiceList value
     * @throws \InvalidArgumentException
     * @param \StructType\ChoiceList $item
     * @return \StructType\GetChoiceListsResponse
     */
    public function addToChoiceList(\StructType\ChoiceList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChoiceList) {
            throw new \InvalidArgumentException(sprintf('The choiceList property can only contain items of type \StructType\ChoiceList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->choiceList[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetChoiceListsResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetChoiceListsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
