<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getContractRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request einen Contract abzuholen
 * @subpackage Structs
 */
class GetContractRequest extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - documentation: login user
     * @var \StructType\Login
     */
    public $login;
    /**
     * The policy
     * Meta information extracted from the WSDL
     * - documentation: Polizzen Informationen für eine Schadenmeldung
     * @var \StructType\Policy
     */
    public $policy;
    /**
     * Constructor method for getContractRequest
     * @uses GetContractRequest::setLogin()
     * @uses GetContractRequest::setPolicy()
     * @param \StructType\Login $login
     * @param \StructType\Policy $policy
     */
    public function __construct(\StructType\Login $login = null, \StructType\Policy $policy = null)
    {
        $this
            ->setLogin($login)
            ->setPolicy($policy);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\GetContractRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get policy value
     * @return \StructType\Policy|null
     */
    public function getPolicy()
    {
        return $this->policy;
    }
    /**
     * Set policy value
     * @param \StructType\Policy $policy
     * @return \StructType\GetContractRequest
     */
    public function setPolicy(\StructType\Policy $policy = null)
    {
        $this->policy = $policy;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetContractRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
