<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getContractResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Liefert den Contract als XML
 * @subpackage Structs
 */
class GetContractResponse extends AbstractStructBase
{
    /**
     * The contract
     * Meta information extracted from the WSDL
     * - documentation: liefert die Vertragsdaten zu einem Vertrag
     * - minOccurs: 0
     * @var \StructType\Contract
     */
    public $contract;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getContractResponse
     * @uses GetContractResponse::setContract()
     * @uses GetContractResponse::setEvpServiceFault()
     * @param \StructType\Contract $contract
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(\StructType\Contract $contract = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setContract($contract)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get contract value
     * @return \StructType\Contract|null
     */
    public function getContract()
    {
        return $this->contract;
    }
    /**
     * Set contract value
     * @param \StructType\Contract $contract
     * @return \StructType\GetContractResponse
     */
    public function setContract(\StructType\Contract $contract = null)
    {
        $this->contract = $contract;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetContractResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetContractResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
