<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getContractsResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Liefert den Contract als XML
 * @subpackage Structs
 */
class GetContractsResponse extends AbstractStructBase
{
    /**
     * The contract
     * Meta information extracted from the WSDL
     * - documentation: liefert die Vertragsdaten zu einem Vertrag
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Contract[]
     */
    public $contract;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getContractsResponse
     * @uses GetContractsResponse::setContract()
     * @uses GetContractsResponse::setEvpServiceFault()
     * @param \StructType\Contract[] $contract
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $contract = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setContract($contract)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get contract value
     * @return \StructType\Contract[]|null
     */
    public function getContract()
    {
        return $this->contract;
    }
    /**
     * This method is responsible for validating the values passed to the setContract method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContract method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContractForArrayConstraintsFromSetContract(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getContractsResponseContractItem) {
            // validation for constraint: itemType
            if (!$getContractsResponseContractItem instanceof \StructType\Contract) {
                $invalidValues[] = is_object($getContractsResponseContractItem) ? get_class($getContractsResponseContractItem) : sprintf('%s(%s)', gettype($getContractsResponseContractItem), var_export($getContractsResponseContractItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The contract property can only contain items of type \StructType\Contract, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set contract value
     * @throws \InvalidArgumentException
     * @param \StructType\Contract[] $contract
     * @return \StructType\GetContractsResponse
     */
    public function setContract(array $contract = array())
    {
        // validation for constraint: array
        if ('' !== ($contractArrayErrorMessage = self::validateContractForArrayConstraintsFromSetContract($contract))) {
            throw new \InvalidArgumentException($contractArrayErrorMessage, __LINE__);
        }
        $this->contract = $contract;
        return $this;
    }
    /**
     * Add item to contract value
     * @throws \InvalidArgumentException
     * @param \StructType\Contract $item
     * @return \StructType\GetContractsResponse
     */
    public function addToContract(\StructType\Contract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Contract) {
            throw new \InvalidArgumentException(sprintf('The contract property can only contain items of type \StructType\Contract, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->contract[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetContractsResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetContractsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
