<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getSignableDocumentsResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Liste mit allen unterschreibbaren Dokumenten und Informationen zu diesen
 * @subpackage Structs
 */
class GetSignableDocumentsResponse extends AbstractStructBase
{
    /**
     * The signableDocument
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SignableDocumentType[]
     */
    public $signableDocument;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getSignableDocumentsResponse
     * @uses GetSignableDocumentsResponse::setSignableDocument()
     * @uses GetSignableDocumentsResponse::setEvpServiceFault()
     * @param \StructType\SignableDocumentType[] $signableDocument
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $signableDocument = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setSignableDocument($signableDocument)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get signableDocument value
     * @return \StructType\SignableDocumentType[]|null
     */
    public function getSignableDocument()
    {
        return $this->signableDocument;
    }
    /**
     * This method is responsible for validating the values passed to the setSignableDocument method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSignableDocument method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSignableDocumentForArrayConstraintsFromSetSignableDocument(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getSignableDocumentsResponseSignableDocumentItem) {
            // validation for constraint: itemType
            if (!$getSignableDocumentsResponseSignableDocumentItem instanceof \StructType\SignableDocumentType) {
                $invalidValues[] = is_object($getSignableDocumentsResponseSignableDocumentItem) ? get_class($getSignableDocumentsResponseSignableDocumentItem) : sprintf('%s(%s)', gettype($getSignableDocumentsResponseSignableDocumentItem), var_export($getSignableDocumentsResponseSignableDocumentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The signableDocument property can only contain items of type \StructType\SignableDocumentType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set signableDocument value
     * @throws \InvalidArgumentException
     * @param \StructType\SignableDocumentType[] $signableDocument
     * @return \StructType\GetSignableDocumentsResponse
     */
    public function setSignableDocument(array $signableDocument = array())
    {
        // validation for constraint: array
        if ('' !== ($signableDocumentArrayErrorMessage = self::validateSignableDocumentForArrayConstraintsFromSetSignableDocument($signableDocument))) {
            throw new \InvalidArgumentException($signableDocumentArrayErrorMessage, __LINE__);
        }
        $this->signableDocument = $signableDocument;
        return $this;
    }
    /**
     * Add item to signableDocument value
     * @throws \InvalidArgumentException
     * @param \StructType\SignableDocumentType $item
     * @return \StructType\GetSignableDocumentsResponse
     */
    public function addToSignableDocument(\StructType\SignableDocumentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SignableDocumentType) {
            throw new \InvalidArgumentException(sprintf('The signableDocument property can only contain items of type \StructType\SignableDocumentType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->signableDocument[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetSignableDocumentsResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSignableDocumentsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
