<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getVinkulierungsdatenRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request for getting Vinkulierungsdaten
 * @subpackage Structs
 */
class GetVinkulierungsdatenRequest extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - documentation: login data of user
     * @var \StructType\Login
     */
    public $login;
    /**
     * The Ort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Ort;
    /**
     * The Plz
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Plz;
    /**
     * The Strasse
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Strasse;
    /**
     * The Hausnummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Hausnummer;
    /**
     * The Postfach
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Postfach;
    /**
     * Constructor method for getVinkulierungsdatenRequest
     * @uses GetVinkulierungsdatenRequest::setLogin()
     * @uses GetVinkulierungsdatenRequest::setOrt()
     * @uses GetVinkulierungsdatenRequest::setPlz()
     * @uses GetVinkulierungsdatenRequest::setStrasse()
     * @uses GetVinkulierungsdatenRequest::setHausnummer()
     * @uses GetVinkulierungsdatenRequest::setPostfach()
     * @param \StructType\Login $login
     * @param string $ort
     * @param string $plz
     * @param string $strasse
     * @param string $hausnummer
     * @param string $postfach
     */
    public function __construct(\StructType\Login $login = null, $ort = null, $plz = null, $strasse = null, $hausnummer = null, $postfach = null)
    {
        $this
            ->setLogin($login)
            ->setOrt($ort)
            ->setPlz($plz)
            ->setStrasse($strasse)
            ->setHausnummer($hausnummer)
            ->setPostfach($postfach);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get Ort value
     * @return string|null
     */
    public function getOrt()
    {
        return $this->Ort;
    }
    /**
     * Set Ort value
     * @param string $ort
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setOrt($ort = null)
    {
        // validation for constraint: string
        if (!is_null($ort) && !is_string($ort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ort, true), gettype($ort)), __LINE__);
        }
        $this->Ort = $ort;
        return $this;
    }
    /**
     * Get Plz value
     * @return string|null
     */
    public function getPlz()
    {
        return $this->Plz;
    }
    /**
     * Set Plz value
     * @param string $plz
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setPlz($plz = null)
    {
        // validation for constraint: string
        if (!is_null($plz) && !is_string($plz)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plz, true), gettype($plz)), __LINE__);
        }
        $this->Plz = $plz;
        return $this;
    }
    /**
     * Get Strasse value
     * @return string|null
     */
    public function getStrasse()
    {
        return $this->Strasse;
    }
    /**
     * Set Strasse value
     * @param string $strasse
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setStrasse($strasse = null)
    {
        // validation for constraint: string
        if (!is_null($strasse) && !is_string($strasse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($strasse, true), gettype($strasse)), __LINE__);
        }
        $this->Strasse = $strasse;
        return $this;
    }
    /**
     * Get Hausnummer value
     * @return string|null
     */
    public function getHausnummer()
    {
        return $this->Hausnummer;
    }
    /**
     * Set Hausnummer value
     * @param string $hausnummer
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setHausnummer($hausnummer = null)
    {
        // validation for constraint: string
        if (!is_null($hausnummer) && !is_string($hausnummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hausnummer, true), gettype($hausnummer)), __LINE__);
        }
        $this->Hausnummer = $hausnummer;
        return $this;
    }
    /**
     * Get Postfach value
     * @return string|null
     */
    public function getPostfach()
    {
        return $this->Postfach;
    }
    /**
     * Set Postfach value
     * @param string $postfach
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public function setPostfach($postfach = null)
    {
        // validation for constraint: string
        if (!is_null($postfach) && !is_string($postfach)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postfach, true), gettype($postfach)), __LINE__);
        }
        $this->Postfach = $postfach;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVinkulierungsdatenRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
