<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getVinkulierungsdatenResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response of the found Vinkulierungsdaten.
 * @subpackage Structs
 */
class GetVinkulierungsdatenResponse extends AbstractStructBase
{
    /**
     * The vinkulierungsdaten
     * Meta information extracted from the WSDL
     * - maxOccurs: 300
     * - minOccurs: 0
     * @var \StructType\Vinkulierungsdaten[]
     */
    public $vinkulierungsdaten;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for getVinkulierungsdatenResponse
     * @uses GetVinkulierungsdatenResponse::setVinkulierungsdaten()
     * @uses GetVinkulierungsdatenResponse::setEvpServiceFault()
     * @param \StructType\Vinkulierungsdaten[] $vinkulierungsdaten
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $vinkulierungsdaten = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setVinkulierungsdaten($vinkulierungsdaten)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get vinkulierungsdaten value
     * @return \StructType\Vinkulierungsdaten[]|null
     */
    public function getVinkulierungsdaten()
    {
        return $this->vinkulierungsdaten;
    }
    /**
     * This method is responsible for validating the values passed to the setVinkulierungsdaten method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVinkulierungsdaten method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVinkulierungsdatenForArrayConstraintsFromSetVinkulierungsdaten(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getVinkulierungsdatenResponseVinkulierungsdatenItem) {
            // validation for constraint: itemType
            if (!$getVinkulierungsdatenResponseVinkulierungsdatenItem instanceof \StructType\Vinkulierungsdaten) {
                $invalidValues[] = is_object($getVinkulierungsdatenResponseVinkulierungsdatenItem) ? get_class($getVinkulierungsdatenResponseVinkulierungsdatenItem) : sprintf('%s(%s)', gettype($getVinkulierungsdatenResponseVinkulierungsdatenItem), var_export($getVinkulierungsdatenResponseVinkulierungsdatenItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The vinkulierungsdaten property can only contain items of type \StructType\Vinkulierungsdaten, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set vinkulierungsdaten value
     * @throws \InvalidArgumentException
     * @param \StructType\Vinkulierungsdaten[] $vinkulierungsdaten
     * @return \StructType\GetVinkulierungsdatenResponse
     */
    public function setVinkulierungsdaten(array $vinkulierungsdaten = array())
    {
        // validation for constraint: array
        if ('' !== ($vinkulierungsdatenArrayErrorMessage = self::validateVinkulierungsdatenForArrayConstraintsFromSetVinkulierungsdaten($vinkulierungsdaten))) {
            throw new \InvalidArgumentException($vinkulierungsdatenArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(300)
        if (is_array($vinkulierungsdaten) && count($vinkulierungsdaten) > 300) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 300', count($vinkulierungsdaten)), __LINE__);
        }
        $this->vinkulierungsdaten = $vinkulierungsdaten;
        return $this;
    }
    /**
     * Add item to vinkulierungsdaten value
     * @throws \InvalidArgumentException
     * @param \StructType\Vinkulierungsdaten $item
     * @return \StructType\GetVinkulierungsdatenResponse
     */
    public function addToVinkulierungsdaten(\StructType\Vinkulierungsdaten $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Vinkulierungsdaten) {
            throw new \InvalidArgumentException(sprintf('The vinkulierungsdaten property can only contain items of type \StructType\Vinkulierungsdaten, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(300)
        if (is_array($this->vinkulierungsdaten) && count($this->vinkulierungsdaten) >= 300) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 300', count($this->vinkulierungsdaten)), __LINE__);
        }
        $this->vinkulierungsdaten[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\GetVinkulierungsdatenResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVinkulierungsdatenResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
