<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for hasZeusDatenResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response of the found ZEUS data. This service is only available in the generali intranet
 * @subpackage Structs
 */
class HasZeusDatenResponse extends AbstractStructBase
{
    /**
     * The hasZeusDaten
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $hasZeusDaten;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for hasZeusDatenResponse
     * @uses HasZeusDatenResponse::setHasZeusDaten()
     * @uses HasZeusDatenResponse::setEvpServiceFault()
     * @param bool $hasZeusDaten
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct($hasZeusDaten = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setHasZeusDaten($hasZeusDaten)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get hasZeusDaten value
     * @return bool
     */
    public function getHasZeusDaten()
    {
        return $this->hasZeusDaten;
    }
    /**
     * Set hasZeusDaten value
     * @param bool $hasZeusDaten
     * @return \StructType\HasZeusDatenResponse
     */
    public function setHasZeusDaten($hasZeusDaten = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasZeusDaten) && !is_bool($hasZeusDaten)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasZeusDaten, true), gettype($hasZeusDaten)), __LINE__);
        }
        $this->hasZeusDaten = $hasZeusDaten;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\HasZeusDatenResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HasZeusDatenResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
