<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kundenportalClaimAdviceResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Kundenportal ClaimAdvice Response
 * @subpackage Structs
 */
class KundenportalClaimAdviceResponse extends AbstractStructBase
{
    /**
     * The businesscaseId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $businesscaseId;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for kundenportalClaimAdviceResponse
     * @uses KundenportalClaimAdviceResponse::setBusinesscaseId()
     * @uses KundenportalClaimAdviceResponse::setEvpServiceFault()
     * @param int $businesscaseId
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct($businesscaseId = null, \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setBusinesscaseId($businesscaseId)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get businesscaseId value
     * @return int|null
     */
    public function getBusinesscaseId()
    {
        return $this->businesscaseId;
    }
    /**
     * Set businesscaseId value
     * @param int $businesscaseId
     * @return \StructType\KundenportalClaimAdviceResponse
     */
    public function setBusinesscaseId($businesscaseId = null)
    {
        // validation for constraint: int
        if (!is_null($businesscaseId) && !(is_int($businesscaseId) || ctype_digit($businesscaseId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($businesscaseId, true), gettype($businesscaseId)), __LINE__);
        }
        $this->businesscaseId = $businesscaseId;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\KundenportalClaimAdviceResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KundenportalClaimAdviceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
