<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kundenportalJwtInvalidateServiceRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request für die JWT Invalidisierung
 * @subpackage Structs
 */
class KundenportalJwtInvalidateServiceRequest extends AbstractStructBase
{
    /**
     * The login
     * @var \StructType\Login
     */
    public $login;
    /**
     * The benutzerID
     * @var string
     */
    public $benutzerID;
    /**
     * Constructor method for kundenportalJwtInvalidateServiceRequest
     * @uses KundenportalJwtInvalidateServiceRequest::setLogin()
     * @uses KundenportalJwtInvalidateServiceRequest::setBenutzerID()
     * @param \StructType\Login $login
     * @param string $benutzerID
     */
    public function __construct(\StructType\Login $login = null, $benutzerID = null)
    {
        $this
            ->setLogin($login)
            ->setBenutzerID($benutzerID);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\KundenportalJwtInvalidateServiceRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get benutzerID value
     * @return string|null
     */
    public function getBenutzerID()
    {
        return $this->benutzerID;
    }
    /**
     * Set benutzerID value
     * @param string $benutzerID
     * @return \StructType\KundenportalJwtInvalidateServiceRequest
     */
    public function setBenutzerID($benutzerID = null)
    {
        // validation for constraint: string
        if (!is_null($benutzerID) && !is_string($benutzerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($benutzerID, true), gettype($benutzerID)), __LINE__);
        }
        $this->benutzerID = $benutzerID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KundenportalJwtInvalidateServiceRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
