<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kundenportalSchliessfachResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Kundenportal Schliessfach Response
 * @subpackage Structs
 */
class KundenportalSchliessfachResponse extends AbstractStructBase
{
    /**
     * The schliessfachEintrag
     * Meta information extracted from the WSDL
     * - documentation: 0..n Schliessfach Einträge
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SchliessfachEintrag[]
     */
    public $schliessfachEintrag;
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - documentation: Optional Fehler
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * Constructor method for kundenportalSchliessfachResponse
     * @uses KundenportalSchliessfachResponse::setSchliessfachEintrag()
     * @uses KundenportalSchliessfachResponse::setEvpServiceFault()
     * @param \StructType\SchliessfachEintrag[] $schliessfachEintrag
     * @param \StructType\EvpServiceFault $evpServiceFault
     */
    public function __construct(array $schliessfachEintrag = array(), \StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this
            ->setSchliessfachEintrag($schliessfachEintrag)
            ->setEvpServiceFault($evpServiceFault);
    }
    /**
     * Get schliessfachEintrag value
     * @return \StructType\SchliessfachEintrag[]|null
     */
    public function getSchliessfachEintrag()
    {
        return $this->schliessfachEintrag;
    }
    /**
     * This method is responsible for validating the values passed to the setSchliessfachEintrag method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSchliessfachEintrag method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSchliessfachEintragForArrayConstraintsFromSetSchliessfachEintrag(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $kundenportalSchliessfachResponseSchliessfachEintragItem) {
            // validation for constraint: itemType
            if (!$kundenportalSchliessfachResponseSchliessfachEintragItem instanceof \StructType\SchliessfachEintrag) {
                $invalidValues[] = is_object($kundenportalSchliessfachResponseSchliessfachEintragItem) ? get_class($kundenportalSchliessfachResponseSchliessfachEintragItem) : sprintf('%s(%s)', gettype($kundenportalSchliessfachResponseSchliessfachEintragItem), var_export($kundenportalSchliessfachResponseSchliessfachEintragItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The schliessfachEintrag property can only contain items of type \StructType\SchliessfachEintrag, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set schliessfachEintrag value
     * @throws \InvalidArgumentException
     * @param \StructType\SchliessfachEintrag[] $schliessfachEintrag
     * @return \StructType\KundenportalSchliessfachResponse
     */
    public function setSchliessfachEintrag(array $schliessfachEintrag = array())
    {
        // validation for constraint: array
        if ('' !== ($schliessfachEintragArrayErrorMessage = self::validateSchliessfachEintragForArrayConstraintsFromSetSchliessfachEintrag($schliessfachEintrag))) {
            throw new \InvalidArgumentException($schliessfachEintragArrayErrorMessage, __LINE__);
        }
        $this->schliessfachEintrag = $schliessfachEintrag;
        return $this;
    }
    /**
     * Add item to schliessfachEintrag value
     * @throws \InvalidArgumentException
     * @param \StructType\SchliessfachEintrag $item
     * @return \StructType\KundenportalSchliessfachResponse
     */
    public function addToSchliessfachEintrag(\StructType\SchliessfachEintrag $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SchliessfachEintrag) {
            throw new \InvalidArgumentException(sprintf('The schliessfachEintrag property can only contain items of type \StructType\SchliessfachEintrag, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->schliessfachEintrag[] = $item;
        return $this;
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\KundenportalSchliessfachResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KundenportalSchliessfachResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
