<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for newBusinessCaseVersicherungsBestaetigungResponse
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Liefert Detailinformationen für diesen Geschäftsfall
 * @subpackage Structs
 */
class NewBusinessCaseVersicherungsBestaetigungResponse extends AbstractStructBase
{
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * The vbNummer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $vbNummer;
    /**
     * The printDocument
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PrintDocument
     */
    public $printDocument;
    /**
     * The httpActionLink
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $httpActionLink;
    /**
     * Constructor method for newBusinessCaseVersicherungsBestaetigungResponse
     * @uses NewBusinessCaseVersicherungsBestaetigungResponse::setEvpServiceFault()
     * @uses NewBusinessCaseVersicherungsBestaetigungResponse::setVbNummer()
     * @uses NewBusinessCaseVersicherungsBestaetigungResponse::setPrintDocument()
     * @uses NewBusinessCaseVersicherungsBestaetigungResponse::setHttpActionLink()
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @param string $vbNummer
     * @param \StructType\PrintDocument $printDocument
     * @param string $httpActionLink
     */
    public function __construct(\StructType\EvpServiceFault $evpServiceFault = null, $vbNummer = null, \StructType\PrintDocument $printDocument = null, $httpActionLink = null)
    {
        $this
            ->setEvpServiceFault($evpServiceFault)
            ->setVbNummer($vbNummer)
            ->setPrintDocument($printDocument)
            ->setHttpActionLink($httpActionLink);
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\NewBusinessCaseVersicherungsBestaetigungResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Get vbNummer value
     * @return string|null
     */
    public function getVbNummer()
    {
        return $this->vbNummer;
    }
    /**
     * Set vbNummer value
     * @param string $vbNummer
     * @return \StructType\NewBusinessCaseVersicherungsBestaetigungResponse
     */
    public function setVbNummer($vbNummer = null)
    {
        // validation for constraint: string
        if (!is_null($vbNummer) && !is_string($vbNummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vbNummer, true), gettype($vbNummer)), __LINE__);
        }
        $this->vbNummer = $vbNummer;
        return $this;
    }
    /**
     * Get printDocument value
     * @return \StructType\PrintDocument|null
     */
    public function getPrintDocument()
    {
        return $this->printDocument;
    }
    /**
     * Set printDocument value
     * @param \StructType\PrintDocument $printDocument
     * @return \StructType\NewBusinessCaseVersicherungsBestaetigungResponse
     */
    public function setPrintDocument(\StructType\PrintDocument $printDocument = null)
    {
        $this->printDocument = $printDocument;
        return $this;
    }
    /**
     * Get httpActionLink value
     * @return string|null
     */
    public function getHttpActionLink()
    {
        return $this->httpActionLink;
    }
    /**
     * Set httpActionLink value
     * @param string $httpActionLink
     * @return \StructType\NewBusinessCaseVersicherungsBestaetigungResponse
     */
    public function setHttpActionLink($httpActionLink = null)
    {
        // validation for constraint: string
        if (!is_null($httpActionLink) && !is_string($httpActionLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($httpActionLink, true), gettype($httpActionLink)), __LINE__);
        }
        $this->httpActionLink = $httpActionLink;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NewBusinessCaseVersicherungsBestaetigungResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
