<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for praemienpruefungType StructType
 * @subpackage Structs
 */
class PraemienpruefungType extends AbstractStructBase
{
    /**
     * The pruefpraemie
     * Meta information extracted from the WSDL
     * - documentation: Diese Prämie wird im Generali-Tarifrechner gegen die errechnete Prämie geprüft. Bei einer größeren Abweichung wird eine Fehlermeldung ausgegeben.
     * @var float
     */
    public $pruefpraemie;
    /**
     * The maxErlaubtePraemienabweichungInProzent
     * Meta information extracted from the WSDL
     * - documentation: Der Erzeuger des XMLs kann hier angeben, wie hoch die maximale Prämienabweichung sein darf. Diese Abweichung wird im Tarifrechner der Generali geprüft. Falls die Prämienabweichung überschritten wird, dann kommt die definierte
     * Fehlermeldung und der Benutzer kann nicht speichern. Um sinnvoll kontrollieren zu können, sollte eine Abweichung von 0.2 - 0.5 angegeben werden.
     * @var float
     */
    public $maxErlaubtePraemienabweichungInProzent;
    /**
     * The fehlermeldungBeiPraemienabweichung
     * Meta information extracted from the WSDL
     * - documentation: Der Ersteller des XMLs kann hier eine Fehlermeldung vorgeben, die bei Überschreitung der Prämienabweichung im Generali-Tarifrechner angezeigt wird.
     * @var string
     */
    public $fehlermeldungBeiPraemienabweichung;
    /**
     * Constructor method for praemienpruefungType
     * @uses PraemienpruefungType::setPruefpraemie()
     * @uses PraemienpruefungType::setMaxErlaubtePraemienabweichungInProzent()
     * @uses PraemienpruefungType::setFehlermeldungBeiPraemienabweichung()
     * @param float $pruefpraemie
     * @param float $maxErlaubtePraemienabweichungInProzent
     * @param string $fehlermeldungBeiPraemienabweichung
     */
    public function __construct($pruefpraemie = null, $maxErlaubtePraemienabweichungInProzent = null, $fehlermeldungBeiPraemienabweichung = null)
    {
        $this
            ->setPruefpraemie($pruefpraemie)
            ->setMaxErlaubtePraemienabweichungInProzent($maxErlaubtePraemienabweichungInProzent)
            ->setFehlermeldungBeiPraemienabweichung($fehlermeldungBeiPraemienabweichung);
    }
    /**
     * Get pruefpraemie value
     * @return float|null
     */
    public function getPruefpraemie()
    {
        return $this->pruefpraemie;
    }
    /**
     * Set pruefpraemie value
     * @param float $pruefpraemie
     * @return \StructType\PraemienpruefungType
     */
    public function setPruefpraemie($pruefpraemie = null)
    {
        // validation for constraint: float
        if (!is_null($pruefpraemie) && !(is_float($pruefpraemie) || is_numeric($pruefpraemie))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pruefpraemie, true), gettype($pruefpraemie)), __LINE__);
        }
        $this->pruefpraemie = $pruefpraemie;
        return $this;
    }
    /**
     * Get maxErlaubtePraemienabweichungInProzent value
     * @return float|null
     */
    public function getMaxErlaubtePraemienabweichungInProzent()
    {
        return $this->maxErlaubtePraemienabweichungInProzent;
    }
    /**
     * Set maxErlaubtePraemienabweichungInProzent value
     * @param float $maxErlaubtePraemienabweichungInProzent
     * @return \StructType\PraemienpruefungType
     */
    public function setMaxErlaubtePraemienabweichungInProzent($maxErlaubtePraemienabweichungInProzent = null)
    {
        // validation for constraint: float
        if (!is_null($maxErlaubtePraemienabweichungInProzent) && !(is_float($maxErlaubtePraemienabweichungInProzent) || is_numeric($maxErlaubtePraemienabweichungInProzent))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($maxErlaubtePraemienabweichungInProzent, true), gettype($maxErlaubtePraemienabweichungInProzent)), __LINE__);
        }
        $this->maxErlaubtePraemienabweichungInProzent = $maxErlaubtePraemienabweichungInProzent;
        return $this;
    }
    /**
     * Get fehlermeldungBeiPraemienabweichung value
     * @return string|null
     */
    public function getFehlermeldungBeiPraemienabweichung()
    {
        return $this->fehlermeldungBeiPraemienabweichung;
    }
    /**
     * Set fehlermeldungBeiPraemienabweichung value
     * @param string $fehlermeldungBeiPraemienabweichung
     * @return \StructType\PraemienpruefungType
     */
    public function setFehlermeldungBeiPraemienabweichung($fehlermeldungBeiPraemienabweichung = null)
    {
        // validation for constraint: string
        if (!is_null($fehlermeldungBeiPraemienabweichung) && !is_string($fehlermeldungBeiPraemienabweichung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fehlermeldungBeiPraemienabweichung, true), gettype($fehlermeldungBeiPraemienabweichung)), __LINE__);
        }
        $this->fehlermeldungBeiPraemienabweichung = $fehlermeldungBeiPraemienabweichung;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PraemienpruefungType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
