<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PushNachrichtDetails StructType
 * @subpackage Structs
 */
class PushNachrichtDetails extends AbstractStructBase
{
    /**
     * The absender
     * @var string
     */
    public $absender;
    /**
     * The betreff
     * @var string
     */
    public $betreff;
    /**
     * The PartnerNr
     * @var string
     */
    public $PartnerNr;
    /**
     * The PolNr
     * @var string
     */
    public $PolNr;
    /**
     * The LstgsNr
     * @var string
     */
    public $LstgsNr;
    /**
     * The KundenKtoNr
     * @var string
     */
    public $KundenKtoNr;
    /**
     * Constructor method for PushNachrichtDetails
     * @uses PushNachrichtDetails::setAbsender()
     * @uses PushNachrichtDetails::setBetreff()
     * @uses PushNachrichtDetails::setPartnerNr()
     * @uses PushNachrichtDetails::setPolNr()
     * @uses PushNachrichtDetails::setLstgsNr()
     * @uses PushNachrichtDetails::setKundenKtoNr()
     * @param string $absender
     * @param string $betreff
     * @param string $partnerNr
     * @param string $polNr
     * @param string $lstgsNr
     * @param string $kundenKtoNr
     */
    public function __construct($absender = null, $betreff = null, $partnerNr = null, $polNr = null, $lstgsNr = null, $kundenKtoNr = null)
    {
        $this
            ->setAbsender($absender)
            ->setBetreff($betreff)
            ->setPartnerNr($partnerNr)
            ->setPolNr($polNr)
            ->setLstgsNr($lstgsNr)
            ->setKundenKtoNr($kundenKtoNr);
    }
    /**
     * Get absender value
     * @return string|null
     */
    public function getAbsender()
    {
        return $this->absender;
    }
    /**
     * Set absender value
     * @param string $absender
     * @return \StructType\PushNachrichtDetails
     */
    public function setAbsender($absender = null)
    {
        // validation for constraint: string
        if (!is_null($absender) && !is_string($absender)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($absender, true), gettype($absender)), __LINE__);
        }
        $this->absender = $absender;
        return $this;
    }
    /**
     * Get betreff value
     * @return string|null
     */
    public function getBetreff()
    {
        return $this->betreff;
    }
    /**
     * Set betreff value
     * @param string $betreff
     * @return \StructType\PushNachrichtDetails
     */
    public function setBetreff($betreff = null)
    {
        // validation for constraint: string
        if (!is_null($betreff) && !is_string($betreff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($betreff, true), gettype($betreff)), __LINE__);
        }
        $this->betreff = $betreff;
        return $this;
    }
    /**
     * Get PartnerNr value
     * @return string|null
     */
    public function getPartnerNr()
    {
        return $this->PartnerNr;
    }
    /**
     * Set PartnerNr value
     * @param string $partnerNr
     * @return \StructType\PushNachrichtDetails
     */
    public function setPartnerNr($partnerNr = null)
    {
        // validation for constraint: string
        if (!is_null($partnerNr) && !is_string($partnerNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partnerNr, true), gettype($partnerNr)), __LINE__);
        }
        $this->PartnerNr = $partnerNr;
        return $this;
    }
    /**
     * Get PolNr value
     * @return string|null
     */
    public function getPolNr()
    {
        return $this->PolNr;
    }
    /**
     * Set PolNr value
     * @param string $polNr
     * @return \StructType\PushNachrichtDetails
     */
    public function setPolNr($polNr = null)
    {
        // validation for constraint: string
        if (!is_null($polNr) && !is_string($polNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($polNr, true), gettype($polNr)), __LINE__);
        }
        $this->PolNr = $polNr;
        return $this;
    }
    /**
     * Get LstgsNr value
     * @return string|null
     */
    public function getLstgsNr()
    {
        return $this->LstgsNr;
    }
    /**
     * Set LstgsNr value
     * @param string $lstgsNr
     * @return \StructType\PushNachrichtDetails
     */
    public function setLstgsNr($lstgsNr = null)
    {
        // validation for constraint: string
        if (!is_null($lstgsNr) && !is_string($lstgsNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lstgsNr, true), gettype($lstgsNr)), __LINE__);
        }
        $this->LstgsNr = $lstgsNr;
        return $this;
    }
    /**
     * Get KundenKtoNr value
     * @return string|null
     */
    public function getKundenKtoNr()
    {
        return $this->KundenKtoNr;
    }
    /**
     * Set KundenKtoNr value
     * @param string $kundenKtoNr
     * @return \StructType\PushNachrichtDetails
     */
    public function setKundenKtoNr($kundenKtoNr = null)
    {
        // validation for constraint: string
        if (!is_null($kundenKtoNr) && !is_string($kundenKtoNr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kundenKtoNr, true), gettype($kundenKtoNr)), __LINE__);
        }
        $this->KundenKtoNr = $kundenKtoNr;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PushNachrichtDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
