<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchContractListRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Request zum Suchen von Verträgen
 * @subpackage Structs
 */
class SearchContractListRequest extends AbstractStructBase
{
    /**
     * The login
     * @var \StructType\Login
     */
    public $login;
    /**
     * The search
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContractSearch
     */
    public $search;
    /**
     * Constructor method for searchContractListRequest
     * @uses SearchContractListRequest::setLogin()
     * @uses SearchContractListRequest::setSearch()
     * @param \StructType\Login $login
     * @param \StructType\ContractSearch $search
     */
    public function __construct(\StructType\Login $login = null, \StructType\ContractSearch $search = null)
    {
        $this
            ->setLogin($login)
            ->setSearch($search);
    }
    /**
     * Get login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\Login $login
     * @return \StructType\SearchContractListRequest
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get search value
     * @return \StructType\ContractSearch|null
     */
    public function getSearch()
    {
        return $this->search;
    }
    /**
     * Set search value
     * @param \StructType\ContractSearch $search
     * @return \StructType\SearchContractListRequest
     */
    public function setSearch(\StructType\ContractSearch $search = null)
    {
        $this->search = $search;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SearchContractListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
