<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sendMessageToMQResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Response if the send was sucessfull or not
 * @subpackage Structs
 */
class SendMessageToMQResponse extends AbstractStructBase
{
    /**
     * The evpServiceFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EvpServiceFault
     */
    public $evpServiceFault;
    /**
     * The mqErrorCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $mqErrorCode;
    /**
     * Constructor method for sendMessageToMQResponse
     * @uses SendMessageToMQResponse::setEvpServiceFault()
     * @uses SendMessageToMQResponse::setMqErrorCode()
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @param int $mqErrorCode
     */
    public function __construct(\StructType\EvpServiceFault $evpServiceFault = null, $mqErrorCode = null)
    {
        $this
            ->setEvpServiceFault($evpServiceFault)
            ->setMqErrorCode($mqErrorCode);
    }
    /**
     * Get evpServiceFault value
     * @return \StructType\EvpServiceFault|null
     */
    public function getEvpServiceFault()
    {
        return $this->evpServiceFault;
    }
    /**
     * Set evpServiceFault value
     * @param \StructType\EvpServiceFault $evpServiceFault
     * @return \StructType\SendMessageToMQResponse
     */
    public function setEvpServiceFault(\StructType\EvpServiceFault $evpServiceFault = null)
    {
        $this->evpServiceFault = $evpServiceFault;
        return $this;
    }
    /**
     * Get mqErrorCode value
     * @return int|null
     */
    public function getMqErrorCode()
    {
        return $this->mqErrorCode;
    }
    /**
     * Set mqErrorCode value
     * @param int $mqErrorCode
     * @return \StructType\SendMessageToMQResponse
     */
    public function setMqErrorCode($mqErrorCode = null)
    {
        // validation for constraint: int
        if (!is_null($mqErrorCode) && !(is_int($mqErrorCode) || ctype_digit($mqErrorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($mqErrorCode, true), gettype($mqErrorCode)), __LINE__);
        }
        $this->mqErrorCode = $mqErrorCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SendMessageToMQResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
