<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sonderausstattungTyp StructType
 * @subpackage Structs
 */
class SonderausstattungTyp extends AbstractStructBase
{
    /**
     * The text
     * Meta information extracted from the WSDL
     * - documentation: Text für die Sonderausstattung
     * @var string
     */
    public $text;
    /**
     * The betrag
     * Meta information extracted from the WSDL
     * - documentation: Betrag für die Sonderausstattung
     * @var int
     */
    public $betrag;
    /**
     * Constructor method for sonderausstattungTyp
     * @uses SonderausstattungTyp::setText()
     * @uses SonderausstattungTyp::setBetrag()
     * @param string $text
     * @param int $betrag
     */
    public function __construct($text = null, $betrag = null)
    {
        $this
            ->setText($text)
            ->setBetrag($betrag);
    }
    /**
     * Get text value
     * @return string|null
     */
    public function getText()
    {
        return $this->text;
    }
    /**
     * Set text value
     * @param string $text
     * @return \StructType\SonderausstattungTyp
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        $this->text = $text;
        return $this;
    }
    /**
     * Get betrag value
     * @return int|null
     */
    public function getBetrag()
    {
        return $this->betrag;
    }
    /**
     * Set betrag value
     * @param int $betrag
     * @return \StructType\SonderausstattungTyp
     */
    public function setBetrag($betrag = null)
    {
        // validation for constraint: int
        if (!is_null($betrag) && !(is_int($betrag) || ctype_digit($betrag))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($betrag, true), gettype($betrag)), __LINE__);
        }
        $this->betrag = $betrag;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SonderausstattungTyp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
