<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for who StructType
 * @subpackage Structs
 */
class Who extends AbstractStructBase
{
    /**
     * The me
     * Meta information extracted from the WSDL
     * - choice: me | other
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $me;
    /**
     * The other
     * Meta information extracted from the WSDL
     * - choice: me | other
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClaimentPerson
     */
    public $other;
    /**
     * Constructor method for who
     * @uses Who::setMe()
     * @uses Who::setOther()
     * @param mixed $me
     * @param \StructType\ClaimentPerson $other
     */
    public function __construct($me = null, \StructType\ClaimentPerson $other = null)
    {
        $this
            ->setMe($me)
            ->setOther($other);
    }
    /**
     * Get me value
     * @return mixed|null
     */
    public function getMe()
    {
        return isset($this->me) ? $this->me : null;
    }
    /**
     * This method is responsible for validating the value passed to the setMe method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMe method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateMeForChoiceConstraintsFromSetMe($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'other',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property me can\'t be set as the property %s is already set. Only one property must be set among these properties: me, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set me value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param mixed $me
     * @return \StructType\Who
     */
    public function setMe($me = null)
    {
        // validation for constraint: choice(me, other)
        if ('' !== ($meChoiceErrorMessage = self::validateMeForChoiceConstraintsFromSetMe($me))) {
            throw new \InvalidArgumentException($meChoiceErrorMessage, __LINE__);
        }
        if (is_null($me) || (is_array($me) && empty($me))) {
            unset($this->me);
        } else {
            $this->me = $me;
        }
        return $this;
    }
    /**
     * Get other value
     * @return \StructType\ClaimentPerson|null
     */
    public function getOther()
    {
        return isset($this->other) ? $this->other : null;
    }
    /**
     * This method is responsible for validating the value passed to the setOther method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOther method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateOtherForChoiceConstraintsFromSetOther($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'me',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property other can\'t be set as the property %s is already set. Only one property must be set among these properties: other, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set other value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClaimentPerson $other
     * @return \StructType\Who
     */
    public function setOther(\StructType\ClaimentPerson $other = null)
    {
        // validation for constraint: choice(me, other)
        if ('' !== ($otherChoiceErrorMessage = self::validateOtherForChoiceConstraintsFromSetOther($other))) {
            throw new \InvalidArgumentException($otherChoiceErrorMessage, __LINE__);
        }
        if (is_null($other) || (is_array($other) && empty($other))) {
            unset($this->other);
        } else {
            $this->other = $other;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Who
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
